BUNDLE_NAME = "cisco_ios_xe"

CAPABILITIES = {
    "ATM-FORUM-TC-MIB": "",
    "ATM-MIB": "1998-10-19",
    "ATM-TC-MIB": "1998-10-19",
    "BGP4-MIB": "1994-05-05",
    "BRIDGE-MIB": "2005-09-19",
    "CISCO-AAA-SERVER-MIB": "2003-11-17",
    "CISCO-AAA-SESSION-MIB": "2006-03-21",
    "CISCO-AAL5-MIB": "2003-09-22",
    "CISCO-ATM-EXT-MIB": "2003-01-06",
    "CISCO-ATM-PVCTRAP-EXTN-MIB": "2003-01-20",
    "CISCO-ATM-QOS-MIB": "2002-06-10",
    "CISCO-BGP4-MIB": "2010-09-30",
    "CISCO-BGP-POLICY-ACCOUNTING-MIB": "2002-07-26",
    "CISCO-BULK-FILE-MIB": "2002-06-10",
    "CISCO-CABLE-SPECTRUM-MIB": "2011-04-08",
    "CISCO-CABLE-WIDEBAND-MIB": "2011-01-05",
    "CISCO-CBP-TARGET-MIB": "2006-05-24",
    "CISCO-CBP-TARGET-TC-MIB": "2006-03-24",
    "CISCO-CBP-TC-MIB": "2008-06-24",
    "CISCO-CDP-MIB": "2005-03-21",
    "CISCO-CEF-MIB": "2006-01-30",
    "CISCO-CEF-TC": "2005-09-30",
    "CISCO-CONFIG-COPY-MIB": "2005-04-06",
    "CISCO-CONFIG-MAN-MIB": "2007-04-27",
    "CISCO-CONTEXT-MAPPING-MIB": "2008-11-22",
    "CISCO-DATA-COLLECTION-MIB": "2002-10-30",
    "CISCO-DIAL-CONTROL-MIB": "2005-05-26",
    "CISCO-DOCS-EXT-MIB": "2017-11-10",
    "CISCO-DOT3-OAM-MIB": "2006-05-31",
    "CISCO-DYNAMIC-TEMPLATE-MIB": "2007-09-06",
    "CISCO-DYNAMIC-TEMPLATE-TC-MIB": "2012-01-27",
    "CISCO-EIGRP-MIB": "2004-11-16",
    "CISCO-EMBEDDED-EVENT-MGR-MIB": "2006-11-07",
    "CISCO-ENHANCED-MEMPOOL-MIB": "2008-12-05",
    "CISCO-ENTITY-ALARM-MIB": "1999-07-06",
    "CISCO-ENTITY-EXT-MIB": "2008-11-24",
    "CISCO-ENTITY-FRU-CONTROL-MIB": "2013-08-19",
    "CISCO-ENTITY-QFP-MIB": "2014-06-18",
    "CISCO-ENTITY-SENSOR-MIB": "2015-01-15",
    "CISCO-ENTITY-VENDORTYPE-OID-MIB": "2014-12-09",
    "CISCO-ENVMON-MIB": "2003-12-01",
    "CISCO-ETHERLIKE-EXT-MIB": "2010-06-04",
    "CISCO-ETHER-CFM-MIB": "2004-12-28",
    "CISCO-FIREWALL-TC": "2006-03-03",
    "CISCO-FLASH-MIB": "2013-08-06",
    "CISCO-FTP-CLIENT-MIB": "2006-03-31",
    "CISCO-HSRP-EXT-MIB": "2010-09-02",
    "CISCO-HSRP-MIB": "2010-09-06",
    "CISCO-IETF-ATM2-PVCTRAP-MIB": "1998-02-03",
    "CISCO-IETF-ATM2-PVCTRAP-MIB-EXTN": "2000-07-11",
    "CISCO-IETF-BFD-MIB": "2011-04-16",
    "CISCO-IETF-FRR-MIB": "2008-04-29",
    "CISCO-IETF-ISIS-MIB": "2005-08-16",
    "CISCO-IETF-MPLS-ID-STD-03-MIB": "2012-06-07",
    "CISCO-IETF-MPLS-TE-EXT-STD-03-MIB": "2012-06-06",
    "CISCO-IETF-PW-ATM-MIB": "2005-04-19",
    "CISCO-IETF-PW-ENET-MIB": "2002-09-22",
    "CISCO-IETF-PW-MIB": "2004-03-17",
    "CISCO-IETF-PW-MPLS-MIB": "2003-02-26",
    "CISCO-IETF-PW-TC-MIB": "2006-07-21",
    "CISCO-IETF-PW-TDM-MIB": "2006-07-21",
    "CISCO-IF-EXTENSION-MIB": "2013-03-13",
    "CISCO-IGMP-FILTER-MIB": "2005-11-29",
    "CISCO-IMAGE-LICENSE-MGMT-MIB": "2007-10-16",
    "CISCO-IMAGE-MIB": "1995-08-15",
    "CISCO-IPMROUTE-MIB": "2005-03-07",
    "CISCO-IPSEC-FLOW-MONITOR-MIB": "2007-10-24",
    "CISCO-IPSEC-MIB": "2000-08-07",
    "CISCO-IPSEC-POLICY-MAP-MIB": "2000-08-17",
    "CISCO-IPSLA-AUTOMEASURE-MIB": "2007-06-13",
    "CISCO-IPSLA-ECHO-MIB": "2007-08-16",
    "CISCO-IPSLA-JITTER-MIB": "2007-07-24",
    "CISCO-IPSLA-TC-MIB": "2007-03-23",
    "CISCO-IP-LOCAL-POOL-MIB": "2007-11-12",
    "CISCO-IP-TAP-MIB": "2004-03-11",
    "CISCO-IP-URPF-MIB": "2011-12-29",
    "CISCO-LICENSE-MGMT-MIB": "2012-04-19",
    "CISCO-MEDIA-GATEWAY-MIB": "2009-02-25",
    "CISCO-MPLS-LSR-EXT-STD-MIB": "2012-04-30",
    "CISCO-MPLS-TC-EXT-STD-MIB": "2012-02-22",
    "CISCO-NBAR-PROTOCOL-DISCOVERY-MIB": "2002-08-16",
    "CISCO-NETSYNC-MIB": "2010-10-15",
    "CISCO-NTP-MIB": "2006-07-31",
    "CISCO-OSPF-MIB": "2003-07-18",
    "CISCO-OSPF-TRAP-MIB": "2003-07-18",
    "CISCO-PIM-MIB": "2000-11-02",
    "CISCO-PING-MIB": "2001-08-28",
    "CISCO-POWER-ETHERNET-EXT-MIB": "2018-01-19",
    "CISCO-PROCESS-MIB": "2011-06-23",
    "CISCO-PRODUCTS-MIB": "2014-11-06",
    "CISCO-PTP-MIB": "2011-01-28",
    "CISCO-QOS-PIB-MIB": "2007-08-29",
    "CISCO-RADIUS-EXT-MIB": "2010-05-25",
    "CISCO-RF-MIB": "2005-09-01",
    "CISCO-RTTMON-MIB": "2012-08-16",
    "CISCO-RTTMON-TC-MIB": "2012-05-25",
    "CISCO-SESS-BORDER-CTRLR-CALL-STATS-MIB": "2010-09-03",
    "CISCO-SESS-BORDER-CTRLR-STATS-MIB": "2010-09-15",
    "CISCO-SIP-UA-MIB": "2004-02-19",
    "CISCO-SMI": "2012-08-29",
    "CISCO-SONET-MIB": "2003-03-07",
    "CISCO-STP-EXTENSIONS-MIB": "2013-03-07",
    "CISCO-ST-TC": "2012-08-08",
    "CISCO-SUBSCRIBER-IDENTITY-TC-MIB": "2011-12-23",
    "CISCO-SUBSCRIBER-SESSION-MIB": "2012-08-08",
    "CISCO-SUBSCRIBER-SESSION-TC-MIB": "2012-01-27",
    "CISCO-SYSLOG-MIB": "2005-12-03",
    "CISCO-TAP2-MIB": "2009-11-06",
    "CISCO-TC": "2011-11-11",
    "CISCO-UBE-MIB": "2010-11-29",
    "CISCO-UNIFIED-FIREWALL-MIB": "2005-09-22",
    "CISCO-VLAN-IFTABLE-RELATIONSHIP-MIB": "2013-07-15",
    "CISCO-VLAN-MEMBERSHIP-MIB": "2007-12-14",
    "CISCO-VOICE-COMMON-DIAL-CONTROL-MIB": "2010-06-30",
    "CISCO-VOICE-DIAL-CONTROL-MIB": "2012-05-15",
    "CISCO-VOICE-DNIS-MIB": "2002-05-01",
    "CISCO-VPDN-MGMT-MIB": "2009-06-16",
    "CISCO-VTP-MIB": "2013-10-14",
    "CLAB-DEF-MIB": "2012-08-09",
    "CLAB-TOPO-MIB": "2006-12-07",
    "Cisco-IOS-XE-aaa": "2018-01-15",
    "Cisco-IOS-XE-aaa-oper": "2018-04-16",
    "Cisco-IOS-XE-acl": "2018-05-31",
    "Cisco-IOS-XE-acl-oper": "2017-02-07",
    "Cisco-IOS-XE-arp": "2018-06-28",
    "Cisco-IOS-XE-arp-oper": "2017-12-13",
    "Cisco-IOS-XE-atm": "2017-02-07",
    "Cisco-IOS-XE-avb": "2017-09-19",
    "Cisco-IOS-XE-bba-group": "2017-02-07",
    "Cisco-IOS-XE-bfd": "2017-11-27",
    "Cisco-IOS-XE-bfd-oper": "2017-09-10",
    "Cisco-IOS-XE-bgp": "2018-06-28",
    "Cisco-IOS-XE-bgp-common-oper": "2017-02-07",
    "Cisco-IOS-XE-bgp-oper": "2017-09-25",
    "Cisco-IOS-XE-bgp-route-oper": "2017-09-25",
    "Cisco-IOS-XE-boot-integrity-oper": "2018-01-31",
    "Cisco-IOS-XE-breakout-port-oper": "2018-01-02",
    "Cisco-IOS-XE-bridge-domain": "2017-02-07",
    "Cisco-IOS-XE-bridge-oper": "2018-03-10",
    "Cisco-IOS-XE-call-home": "2017-02-07",
    "Cisco-IOS-XE-card": "2018-03-27",
    "Cisco-IOS-XE-cdp": "2017-11-27",
    "Cisco-IOS-XE-cdp-oper": "2017-09-21",
    "Cisco-IOS-XE-cef": "2017-05-19",
    "Cisco-IOS-XE-cellular": "2017-12-20",
    "Cisco-IOS-XE-cellwan-oper": "2018-09-04",
    "Cisco-IOS-XE-cfm-oper": "2017-06-06",
    "Cisco-IOS-XE-checkpoint-archive-oper": "2017-04-01",
    "Cisco-IOS-XE-coap": "2017-02-07",
    "Cisco-IOS-XE-common-types": "2017-12-01",
    "Cisco-IOS-XE-controller": "2018-04-02",
    "Cisco-IOS-XE-controller-vdsl-oper": "2018-01-31",
    "Cisco-IOS-XE-crypto": "2018-06-28",
    "Cisco-IOS-XE-cts": "2017-11-27",
    "Cisco-IOS-XE-device-hardware-oper": "2017-11-01",
    "Cisco-IOS-XE-device-sensor": "2017-02-07",
    "Cisco-IOS-XE-device-tracking": "2017-06-07",
    "Cisco-IOS-XE-dhcp": "2018-06-16",
    "Cisco-IOS-XE-dhcp-oper": "2018-02-13",
    "Cisco-IOS-XE-diagnostics": "2017-02-07",
    "Cisco-IOS-XE-diffserv-target-oper": "2017-02-09",
    "Cisco-IOS-XE-dot1x": "2017-11-27",
    "Cisco-IOS-XE-eem": "2017-12-20",
    "Cisco-IOS-XE-efp-oper": "2017-02-07",
    "Cisco-IOS-XE-eigrp": "2018-06-28",
    "Cisco-IOS-XE-environment-oper": "2017-11-27",
    "Cisco-IOS-XE-eta": "2018-06-28",
    "Cisco-IOS-XE-ethernet": "2018-04-09",
    "Cisco-IOS-XE-event-history-types": "2018-03-20",
    "Cisco-IOS-XE-ezpm": "2017-11-27",
    "Cisco-IOS-XE-features": "2017-02-07",
    "Cisco-IOS-XE-fib-oper": "2018-03-07",
    "Cisco-IOS-XE-flow": "2018-01-04",
    "Cisco-IOS-XE-flow-monitor-oper": "2017-11-30",
    "Cisco-IOS-XE-fw-oper": "2018-02-22",
    "Cisco-IOS-XE-http": "2018-01-24",
    "Cisco-IOS-XE-icmp": "2017-11-27",
    "Cisco-IOS-XE-igmp": "2017-11-27",
    "Cisco-IOS-XE-interface-common": "2018-02-08",
    "Cisco-IOS-XE-interfaces": "2018-06-28",
    "Cisco-IOS-XE-interfaces-oper": "2018-02-01",
    "Cisco-IOS-XE-ios-common-oper": "2018-01-04",
    "Cisco-IOS-XE-ios-events-oper": "2017-10-10",
    "Cisco-IOS-XE-ip": "2018-05-09",
    "Cisco-IOS-XE-ip-sla-oper": "2017-09-25",
    "Cisco-IOS-XE-ipv6": "2018-06-28",
    "Cisco-IOS-XE-ipv6-oper": "2017-11-01",
    "Cisco-IOS-XE-isis": "2018-06-28",
    "Cisco-IOS-XE-iwanfabric": "2017-11-27",
    "Cisco-IOS-XE-l2vpn": "2018-02-13",
    "Cisco-IOS-XE-l3vpn": "2017-02-07",
    "Cisco-IOS-XE-license": "2017-12-01",
    "Cisco-IOS-XE-line": "2018-03-01",
    "Cisco-IOS-XE-linecard-oper": "2018-03-26",
    "Cisco-IOS-XE-lisp": "2018-04-17",
    "Cisco-IOS-XE-lisp-oper": "2018-02-20",
    "Cisco-IOS-XE-lldp": "2017-11-27",
    "Cisco-IOS-XE-lldp-oper": "2017-02-07",
    "Cisco-IOS-XE-logging": "2018-03-18",
    "Cisco-IOS-XE-mdt-cfg": "2018-02-12",
    "Cisco-IOS-XE-mdt-common-defs": "2018-02-12",
    "Cisco-IOS-XE-mdt-oper": "2018-03-06",
    "Cisco-IOS-XE-memory-oper": "2017-04-01",
    "Cisco-IOS-XE-mka": "2017-11-27",
    "Cisco-IOS-XE-mld": "2018-02-12",
    "Cisco-IOS-XE-mmode": "2017-11-29",
    "Cisco-IOS-XE-mpls": "2018-06-28",
    "Cisco-IOS-XE-mpls-forwarding-oper": "2017-11-01",
    "Cisco-IOS-XE-multicast": "2018-06-28",
    "Cisco-IOS-XE-mvrp": "2017-11-27",
    "Cisco-IOS-XE-nam": "2017-12-28",
    "Cisco-IOS-XE-nat": "2018-06-30",
    "Cisco-IOS-XE-nat-oper": "2018-03-17",
    "Cisco-IOS-XE-native": "2018-05-22",
    "Cisco-IOS-XE-nbar": "2018-06-06",
    "Cisco-IOS-XE-nd": "2017-11-27",
    "Cisco-IOS-XE-nhrp": "2017-02-07",
    "Cisco-IOS-XE-ntp": "2018-06-28",
    "Cisco-IOS-XE-ntp-oper": "2018-01-16",
    "Cisco-IOS-XE-object-group": "2017-07-31",
    "Cisco-IOS-XE-ospf": "2018-06-28",
    "Cisco-IOS-XE-ospf-oper": "2018-02-01",
    "Cisco-IOS-XE-ospfv3": "2018-06-28",
    "Cisco-IOS-XE-otv": "2017-02-07",
    "Cisco-IOS-XE-parser": "2018-03-01",
    "Cisco-IOS-XE-pathmgr": "2017-02-07",
    "Cisco-IOS-XE-pfr": "2017-02-07",
    "Cisco-IOS-XE-platform": "2018-05-17",
    "Cisco-IOS-XE-platform-oper": "2017-10-11",
    "Cisco-IOS-XE-platform-software-oper": "2018-03-09",
    "Cisco-IOS-XE-poe-oper": "2018-02-04",
    "Cisco-IOS-XE-policy": "2018-06-28",
    "Cisco-IOS-XE-power": "2017-11-27",
    "Cisco-IOS-XE-ppp": "2018-02-03",
    "Cisco-IOS-XE-ppp-oper": "2018-02-19",
    "Cisco-IOS-XE-process-cpu-oper": "2017-02-07",
    "Cisco-IOS-XE-process-memory-oper": "2017-02-07",
    "Cisco-IOS-XE-ptp": "2017-09-19",
    "Cisco-IOS-XE-qos": "2017-02-07",
    "Cisco-IOS-XE-rip": "2018-06-28",
    "Cisco-IOS-XE-route-map": "2018-03-08",
    "Cisco-IOS-XE-rpc": "2018-04-18",
    "Cisco-IOS-XE-rsvp": "2017-11-27",
    "Cisco-IOS-XE-sanet": "2017-11-27",
    "Cisco-IOS-XE-segment-routing": "2017-02-07",
    "Cisco-IOS-XE-service-chain": "2017-02-07",
    "Cisco-IOS-XE-service-discovery": "2017-02-07",
    "Cisco-IOS-XE-service-insertion": "2017-02-07",
    "Cisco-IOS-XE-service-routing": "2017-07-24",
    "Cisco-IOS-XE-sla": "2018-06-28",
    "Cisco-IOS-XE-snmp": "2018-06-28",
    "Cisco-IOS-XE-spanning-tree": "2017-11-27",
    "Cisco-IOS-XE-spanning-tree-oper": "2017-08-10",
    "Cisco-IOS-XE-stackwise-virtual": "2017-06-05",
    "Cisco-IOS-XE-switch": "2018-01-10",
    "Cisco-IOS-XE-tcam-oper": "2017-06-06",
    "Cisco-IOS-XE-template": "2017-11-06",
    "Cisco-IOS-XE-track": "2017-04-28",
    "Cisco-IOS-XE-transceiver-oper": "2018-01-18",
    "Cisco-IOS-XE-trustsec-oper": "2017-02-07",
    "Cisco-IOS-XE-tunnel": "2017-08-28",
    "Cisco-IOS-XE-types": "2018-05-22",
    "Cisco-IOS-XE-udld": "2017-11-27",
    "Cisco-IOS-XE-umbrella": "2018-05-14",
    "Cisco-IOS-XE-utd": "2018-06-28",
    "Cisco-IOS-XE-utd-common-oper": "2018-04-04",
    "Cisco-IOS-XE-utd-oper": "2018-04-04",
    "Cisco-IOS-XE-virtual-service-cfg": "2018-01-01",
    "Cisco-IOS-XE-virtual-service-oper": "2018-02-01",
    "Cisco-IOS-XE-vlan": "2018-03-13",
    "Cisco-IOS-XE-vlan-oper": "2018-04-09",
    "Cisco-IOS-XE-voice": "2017-02-07",
    "Cisco-IOS-XE-vpdn": "2017-02-07",
    "Cisco-IOS-XE-vrrp": "2018-06-28",
    "Cisco-IOS-XE-vrrp-oper": "2018-05-10",
    "Cisco-IOS-XE-vservice": "2017-11-27",
    "Cisco-IOS-XE-vstack": "2017-02-07",
    "Cisco-IOS-XE-vtp": "2017-02-07",
    "Cisco-IOS-XE-wccp": "2017-11-27",
    "Cisco-IOS-XE-wsma": "2017-02-07",
    "Cisco-IOS-XE-zone": "2018-06-12",
    "DIAL-CONTROL-MIB": "1996-09-23",
    "DIFFSERV-DSCP-TC": "2002-05-09",
    "DIFFSERV-MIB": "2002-02-07",
    "DISMAN-EVENT-MIB": "2000-10-16",
    "DISMAN-EXPRESSION-MIB": "2000-10-16",
    "DOCS-CABLE-DEVICE-MIB": "2006-12-20",
    "DOCS-IETF-BPI2-MIB": "2004-09-07",
    "DOCS-IF3-MIB": "2016-05-05",
    "DOCS-IF-MIB": "2007-09-12",
    "DOCS-L2VPN-MIB": "2006-03-28",
    "DOCS-QOS-MIB": "2001-11-09",
    "DOCS-SUBMGT3-MIB": "2007-05-18",
    "DRAFT-MSDP-MIB": "1999-12-16",
    "DS1-MIB": "1998-08-01",
    "DS3-MIB": "1998-08-01",
    "ENTITY-MIB": "2005-08-10",
    "ENTITY-SENSOR-MIB": "2002-12-16",
    "ENTITY-STATE-MIB": "2005-11-22",
    "ENTITY-STATE-TC-MIB": "2005-11-22",
    "ETHER-WIS": "2003-09-19",
    "EXPRESSION-MIB": "2005-11-24",
    "EtherLike-MIB": "2003-09-19",
    "FRAME-RELAY-DTE-MIB": "1997-05-01",
    "HCNUM-TC": "2000-06-08",
    "IANA-ADDRESS-FAMILY-NUMBERS-MIB": "2000-09-08",
    "IANA-RTPROTO-MIB": "2000-09-26",
    "IANAifType-MIB": "2006-03-31",
    "IEEE8021-TC-MIB": "2008-10-15",
    "IF-MIB": "2000-06-14",
    "IGMP-STD-MIB": "2000-09-28",
    "INET-ADDRESS-MIB": "2005-02-04",
    "INTEGRATED-SERVICES-MIB": "1995-11-03",
    "INT-SERV-MIB": "1997-10-03",
    "IPMROUTE-STD-MIB": "2000-09-22",
    "IPV6-FLOW-LABEL-MIB": "2003-08-28",
    "IP-FORWARD-MIB": "1996-09-19",
    "IP-MIB": "2006-02-02",
    "LLDP-MIB": "2005-05-06",
    "MPLS-L3VPN-STD-MIB": "2006-01-23",
    "MPLS-LDP-GENERIC-STD-MIB": "2004-06-03",
    "MPLS-LDP-STD-MIB": "2004-06-03",
    "MPLS-LSR-STD-MIB": "2004-06-03",
    "MPLS-TC-MIB": "2001-01-04",
    "MPLS-TC-STD-MIB": "2004-06-03",
    "MPLS-TE-STD-MIB": "2004-06-03",
    "MPLS-VPN-MIB": "2001-10-15",
    "NHRP-MIB": "1999-08-26",
    "NOTIFICATION-LOG-MIB": "2000-11-27",
    "OLD-CISCO-INTERFACES-MIB": "",
    "OSPF-MIB": "2006-11-10",
    "OSPF-TRAP-MIB": "2006-11-10",
    "PIM-MIB": "2000-09-28",
    "POWER-ETHERNET-MIB": "2003-11-24",
    "P-BRIDGE-MIB": "2006-01-09",
    "PerfHist-TC-MIB": "1998-11-07",
    "Q-BRIDGE-MIB": "2006-01-09",
    "RFC1155-SMI": "",
    "RFC1213-MIB": "",
    "RFC1315-MIB": "",
    "RFC-1212": "",
    "RFC-1215": "",
    "RMON2-MIB": "1996-05-27",
    "RMON-MIB": "2000-05-11",
    "RSVP-MIB": "1998-08-25",
    "SNMP-FRAMEWORK-MIB": "2002-10-14",
    "SNMP-PROXY-MIB": "2002-10-14",
    "SNMP-TARGET-MIB": "1998-08-04",
    "SNMPv2-MIB": "2002-10-16",
    "SNMPv2-TC": "",
    "SONET-MIB": "2003-08-11",
    "TCP-MIB": "2005-02-18",
    "TOKENRING-MIB": "1994-10-23",
    "TOKEN-RING-RMON-MIB": "",
    "TUNNEL-MIB": "2005-05-16",
    "UDP-MIB": "2005-05-20",
    "VPN-TC-STD-MIB": "2005-11-15",
    "cisco-bridge-common": "2016-12-14",
    "cisco-bridge-domain": "2016-12-14",
    "cisco-ethernet": "2016-05-10",
    "cisco-ia": "2018-03-28",
    "cisco-ospf": "2016-03-30",
    "cisco-policy": "2016-03-30",
    "cisco-policy-filters": "2016-03-30",
    "cisco-policy-target": "2016-03-30",
    "cisco-pw": "2016-12-07",
    "cisco-routing-ext": "2016-07-09",
    "cisco-self-mgmt": "2016-05-14",
    "cisco-smart-license": "2017-10-11",
    "cisco-smart-license-errors": "2017-10-11",
    "cisco-storm-control": "2016-12-14",
    "common-mpls-static": "2015-07-22",
    "common-mpls-types": "2015-05-28",
    "nvo": "2015-06-02",
    "pim": "2014-06-27",
    "policy-attr": "2015-04-27",
    "policy-types": "2013-10-07",
    "policy-types": "2013-10-07",
    "tailf-cli-extensions": "2017-08-23",
    "tailf-common": "2017-09-28",
    "tailf-common-monitoring": "2013-06-14",
    "tailf-common-query": "2017-12-15",
    "tailf-confd-monitoring": "2013-06-14",
    "tailf-meta-extensions": "2017-03-08",
    "tailf-netconf-inactive": "",
    "tailf-netconf-monitoring": "2016-11-24",
    "tailf-netconf-query": "2017-01-06",
    "tailf-netconf-transactions": "",
    "tailf-rest-error": "",
    "tailf-rest-query": "2017-01-06",
    "tailf-xsd-types": "2009-03-17",
}

ENTITY_LOOKUP = {
    ("urn:ietf:params:xml:ns:yang:smiv2:ATM-MIB", "ATM-MIB"): "ATM_MIB.ATMMIB",
    ("ATM-MIB", "ATM-MIB"): "ATM_MIB.ATMMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:BGP4-MIB", "BGP4-MIB"): "BGP4_MIB.BGP4MIB",
    ("BGP4-MIB", "BGP4-MIB"): "BGP4_MIB.BGP4MIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:BRIDGE-MIB", "BRIDGE-MIB"): "BRIDGE_MIB.BRIDGEMIB",
    ("BRIDGE-MIB", "BRIDGE-MIB"): "BRIDGE_MIB.BRIDGEMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-AAA-SERVER-MIB", "CISCO-AAA-SERVER-MIB"): "CISCO_AAA_SERVER_MIB.CISCOAAASERVERMIB",
    ("CISCO-AAA-SERVER-MIB", "CISCO-AAA-SERVER-MIB"): "CISCO_AAA_SERVER_MIB.CISCOAAASERVERMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-AAA-SESSION-MIB", "CISCO-AAA-SESSION-MIB"): "CISCO_AAA_SESSION_MIB.CISCOAAASESSIONMIB",
    ("CISCO-AAA-SESSION-MIB", "CISCO-AAA-SESSION-MIB"): "CISCO_AAA_SESSION_MIB.CISCOAAASESSIONMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-ATM-PVCTRAP-EXTN-MIB", "CISCO-ATM-PVCTRAP-EXTN-MIB"): "CISCO_ATM_PVCTRAP_EXTN_MIB.CISCOATMPVCTRAPEXTNMIB",
    ("CISCO-ATM-PVCTRAP-EXTN-MIB", "CISCO-ATM-PVCTRAP-EXTN-MIB"): "CISCO_ATM_PVCTRAP_EXTN_MIB.CISCOATMPVCTRAPEXTNMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-ATM-QOS-MIB", "CISCO-ATM-QOS-MIB"): "CISCO_ATM_QOS_MIB.CISCOATMQOSMIB",
    ("CISCO-ATM-QOS-MIB", "CISCO-ATM-QOS-MIB"): "CISCO_ATM_QOS_MIB.CISCOATMQOSMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-BGP4-MIB", "CISCO-BGP4-MIB"): "CISCO_BGP4_MIB.CISCOBGP4MIB",
    ("CISCO-BGP4-MIB", "CISCO-BGP4-MIB"): "CISCO_BGP4_MIB.CISCOBGP4MIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-BGP-POLICY-ACCOUNTING-MIB", "CISCO-BGP-POLICY-ACCOUNTING-MIB"): "CISCO_BGP_POLICY_ACCOUNTING_MIB.CISCOBGPPOLICYACCOUNTINGMIB",
    ("CISCO-BGP-POLICY-ACCOUNTING-MIB", "CISCO-BGP-POLICY-ACCOUNTING-MIB"): "CISCO_BGP_POLICY_ACCOUNTING_MIB.CISCOBGPPOLICYACCOUNTINGMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-BULK-FILE-MIB", "CISCO-BULK-FILE-MIB"): "CISCO_BULK_FILE_MIB.CISCOBULKFILEMIB",
    ("CISCO-BULK-FILE-MIB", "CISCO-BULK-FILE-MIB"): "CISCO_BULK_FILE_MIB.CISCOBULKFILEMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-CABLE-SPECTRUM-MIB", "CISCO-CABLE-SPECTRUM-MIB"): "CISCO_CABLE_SPECTRUM_MIB.CISCOCABLESPECTRUMMIB",
    ("CISCO-CABLE-SPECTRUM-MIB", "CISCO-CABLE-SPECTRUM-MIB"): "CISCO_CABLE_SPECTRUM_MIB.CISCOCABLESPECTRUMMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-CABLE-WIDEBAND-MIB", "CISCO-CABLE-WIDEBAND-MIB"): "CISCO_CABLE_WIDEBAND_MIB.CISCOCABLEWIDEBANDMIB",
    ("CISCO-CABLE-WIDEBAND-MIB", "CISCO-CABLE-WIDEBAND-MIB"): "CISCO_CABLE_WIDEBAND_MIB.CISCOCABLEWIDEBANDMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-CBP-TARGET-MIB", "CISCO-CBP-TARGET-MIB"): "CISCO_CBP_TARGET_MIB.CISCOCBPTARGETMIB",
    ("CISCO-CBP-TARGET-MIB", "CISCO-CBP-TARGET-MIB"): "CISCO_CBP_TARGET_MIB.CISCOCBPTARGETMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-CDP-MIB", "CISCO-CDP-MIB"): "CISCO_CDP_MIB.CISCOCDPMIB",
    ("CISCO-CDP-MIB", "CISCO-CDP-MIB"): "CISCO_CDP_MIB.CISCOCDPMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-CEF-MIB", "CISCO-CEF-MIB"): "CISCO_CEF_MIB.CISCOCEFMIB",
    ("CISCO-CEF-MIB", "CISCO-CEF-MIB"): "CISCO_CEF_MIB.CISCOCEFMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-CONFIG-COPY-MIB", "CISCO-CONFIG-COPY-MIB"): "CISCO_CONFIG_COPY_MIB.CISCOCONFIGCOPYMIB",
    ("CISCO-CONFIG-COPY-MIB", "CISCO-CONFIG-COPY-MIB"): "CISCO_CONFIG_COPY_MIB.CISCOCONFIGCOPYMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-CONFIG-MAN-MIB", "CISCO-CONFIG-MAN-MIB"): "CISCO_CONFIG_MAN_MIB.CISCOCONFIGMANMIB",
    ("CISCO-CONFIG-MAN-MIB", "CISCO-CONFIG-MAN-MIB"): "CISCO_CONFIG_MAN_MIB.CISCOCONFIGMANMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-CONTEXT-MAPPING-MIB", "CISCO-CONTEXT-MAPPING-MIB"): "CISCO_CONTEXT_MAPPING_MIB.CISCOCONTEXTMAPPINGMIB",
    ("CISCO-CONTEXT-MAPPING-MIB", "CISCO-CONTEXT-MAPPING-MIB"): "CISCO_CONTEXT_MAPPING_MIB.CISCOCONTEXTMAPPINGMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-DATA-COLLECTION-MIB", "CISCO-DATA-COLLECTION-MIB"): "CISCO_DATA_COLLECTION_MIB.CISCODATACOLLECTIONMIB",
    ("CISCO-DATA-COLLECTION-MIB", "CISCO-DATA-COLLECTION-MIB"): "CISCO_DATA_COLLECTION_MIB.CISCODATACOLLECTIONMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-DIAL-CONTROL-MIB", "CISCO-DIAL-CONTROL-MIB"): "CISCO_DIAL_CONTROL_MIB.CISCODIALCONTROLMIB",
    ("CISCO-DIAL-CONTROL-MIB", "CISCO-DIAL-CONTROL-MIB"): "CISCO_DIAL_CONTROL_MIB.CISCODIALCONTROLMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-DOCS-EXT-MIB", "CISCO-DOCS-EXT-MIB"): "CISCO_DOCS_EXT_MIB.CISCODOCSEXTMIB",
    ("CISCO-DOCS-EXT-MIB", "CISCO-DOCS-EXT-MIB"): "CISCO_DOCS_EXT_MIB.CISCODOCSEXTMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-DOT3-OAM-MIB", "CISCO-DOT3-OAM-MIB"): "CISCO_DOT3_OAM_MIB.CISCODOT3OAMMIB",
    ("CISCO-DOT3-OAM-MIB", "CISCO-DOT3-OAM-MIB"): "CISCO_DOT3_OAM_MIB.CISCODOT3OAMMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-DYNAMIC-TEMPLATE-MIB", "CISCO-DYNAMIC-TEMPLATE-MIB"): "CISCO_DYNAMIC_TEMPLATE_MIB.CISCODYNAMICTEMPLATEMIB",
    ("CISCO-DYNAMIC-TEMPLATE-MIB", "CISCO-DYNAMIC-TEMPLATE-MIB"): "CISCO_DYNAMIC_TEMPLATE_MIB.CISCODYNAMICTEMPLATEMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-EIGRP-MIB", "CISCO-EIGRP-MIB"): "CISCO_EIGRP_MIB.CISCOEIGRPMIB",
    ("CISCO-EIGRP-MIB", "CISCO-EIGRP-MIB"): "CISCO_EIGRP_MIB.CISCOEIGRPMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-EMBEDDED-EVENT-MGR-MIB", "CISCO-EMBEDDED-EVENT-MGR-MIB"): "CISCO_EMBEDDED_EVENT_MGR_MIB.CISCOEMBEDDEDEVENTMGRMIB",
    ("CISCO-EMBEDDED-EVENT-MGR-MIB", "CISCO-EMBEDDED-EVENT-MGR-MIB"): "CISCO_EMBEDDED_EVENT_MGR_MIB.CISCOEMBEDDEDEVENTMGRMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-ENHANCED-MEMPOOL-MIB", "CISCO-ENHANCED-MEMPOOL-MIB"): "CISCO_ENHANCED_MEMPOOL_MIB.CISCOENHANCEDMEMPOOLMIB",
    ("CISCO-ENHANCED-MEMPOOL-MIB", "CISCO-ENHANCED-MEMPOOL-MIB"): "CISCO_ENHANCED_MEMPOOL_MIB.CISCOENHANCEDMEMPOOLMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-ENTITY-ALARM-MIB", "CISCO-ENTITY-ALARM-MIB"): "CISCO_ENTITY_ALARM_MIB.CISCOENTITYALARMMIB",
    ("CISCO-ENTITY-ALARM-MIB", "CISCO-ENTITY-ALARM-MIB"): "CISCO_ENTITY_ALARM_MIB.CISCOENTITYALARMMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-ENTITY-EXT-MIB", "CISCO-ENTITY-EXT-MIB"): "CISCO_ENTITY_EXT_MIB.CISCOENTITYEXTMIB",
    ("CISCO-ENTITY-EXT-MIB", "CISCO-ENTITY-EXT-MIB"): "CISCO_ENTITY_EXT_MIB.CISCOENTITYEXTMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-ENTITY-FRU-CONTROL-MIB", "CISCO-ENTITY-FRU-CONTROL-MIB"): "CISCO_ENTITY_FRU_CONTROL_MIB.CISCOENTITYFRUCONTROLMIB",
    ("CISCO-ENTITY-FRU-CONTROL-MIB", "CISCO-ENTITY-FRU-CONTROL-MIB"): "CISCO_ENTITY_FRU_CONTROL_MIB.CISCOENTITYFRUCONTROLMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-ENTITY-QFP-MIB", "CISCO-ENTITY-QFP-MIB"): "CISCO_ENTITY_QFP_MIB.CISCOENTITYQFPMIB",
    ("CISCO-ENTITY-QFP-MIB", "CISCO-ENTITY-QFP-MIB"): "CISCO_ENTITY_QFP_MIB.CISCOENTITYQFPMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-ENTITY-SENSOR-MIB", "CISCO-ENTITY-SENSOR-MIB"): "CISCO_ENTITY_SENSOR_MIB.CISCOENTITYSENSORMIB",
    ("CISCO-ENTITY-SENSOR-MIB", "CISCO-ENTITY-SENSOR-MIB"): "CISCO_ENTITY_SENSOR_MIB.CISCOENTITYSENSORMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-ENVMON-MIB", "CISCO-ENVMON-MIB"): "CISCO_ENVMON_MIB.CISCOENVMONMIB",
    ("CISCO-ENVMON-MIB", "CISCO-ENVMON-MIB"): "CISCO_ENVMON_MIB.CISCOENVMONMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-ETHERLIKE-EXT-MIB", "CISCO-ETHERLIKE-EXT-MIB"): "CISCO_ETHERLIKE_EXT_MIB.CISCOETHERLIKEEXTMIB",
    ("CISCO-ETHERLIKE-EXT-MIB", "CISCO-ETHERLIKE-EXT-MIB"): "CISCO_ETHERLIKE_EXT_MIB.CISCOETHERLIKEEXTMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-ETHER-CFM-MIB", "CISCO-ETHER-CFM-MIB"): "CISCO_ETHER_CFM_MIB.CISCOETHERCFMMIB",
    ("CISCO-ETHER-CFM-MIB", "CISCO-ETHER-CFM-MIB"): "CISCO_ETHER_CFM_MIB.CISCOETHERCFMMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-FLASH-MIB", "CISCO-FLASH-MIB"): "CISCO_FLASH_MIB.CISCOFLASHMIB",
    ("CISCO-FLASH-MIB", "CISCO-FLASH-MIB"): "CISCO_FLASH_MIB.CISCOFLASHMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-FTP-CLIENT-MIB", "CISCO-FTP-CLIENT-MIB"): "CISCO_FTP_CLIENT_MIB.CISCOFTPCLIENTMIB",
    ("CISCO-FTP-CLIENT-MIB", "CISCO-FTP-CLIENT-MIB"): "CISCO_FTP_CLIENT_MIB.CISCOFTPCLIENTMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-HSRP-EXT-MIB", "CISCO-HSRP-EXT-MIB"): "CISCO_HSRP_EXT_MIB.CISCOHSRPEXTMIB",
    ("CISCO-HSRP-EXT-MIB", "CISCO-HSRP-EXT-MIB"): "CISCO_HSRP_EXT_MIB.CISCOHSRPEXTMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-HSRP-MIB", "CISCO-HSRP-MIB"): "CISCO_HSRP_MIB.CISCOHSRPMIB",
    ("CISCO-HSRP-MIB", "CISCO-HSRP-MIB"): "CISCO_HSRP_MIB.CISCOHSRPMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-IETF-ATM2-PVCTRAP-MIB", "CISCO-IETF-ATM2-PVCTRAP-MIB"): "CISCO_IETF_ATM2_PVCTRAP_MIB.CISCOIETFATM2PVCTRAPMIB",
    ("CISCO-IETF-ATM2-PVCTRAP-MIB", "CISCO-IETF-ATM2-PVCTRAP-MIB"): "CISCO_IETF_ATM2_PVCTRAP_MIB.CISCOIETFATM2PVCTRAPMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-IETF-ATM2-PVCTRAP-MIB-EXTN", "CISCO-IETF-ATM2-PVCTRAP-MIB-EXTN"): "CISCO_IETF_ATM2_PVCTRAP_MIB_EXTN.CISCOIETFATM2PVCTRAPMIBEXTN",
    ("CISCO-IETF-ATM2-PVCTRAP-MIB-EXTN", "CISCO-IETF-ATM2-PVCTRAP-MIB-EXTN"): "CISCO_IETF_ATM2_PVCTRAP_MIB_EXTN.CISCOIETFATM2PVCTRAPMIBEXTN",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-IETF-BFD-MIB", "CISCO-IETF-BFD-MIB"): "CISCO_IETF_BFD_MIB.CISCOIETFBFDMIB",
    ("CISCO-IETF-BFD-MIB", "CISCO-IETF-BFD-MIB"): "CISCO_IETF_BFD_MIB.CISCOIETFBFDMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-IETF-FRR-MIB", "CISCO-IETF-FRR-MIB"): "CISCO_IETF_FRR_MIB.CISCOIETFFRRMIB",
    ("CISCO-IETF-FRR-MIB", "CISCO-IETF-FRR-MIB"): "CISCO_IETF_FRR_MIB.CISCOIETFFRRMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-IETF-ISIS-MIB", "CISCO-IETF-ISIS-MIB"): "CISCO_IETF_ISIS_MIB.CISCOIETFISISMIB",
    ("CISCO-IETF-ISIS-MIB", "CISCO-IETF-ISIS-MIB"): "CISCO_IETF_ISIS_MIB.CISCOIETFISISMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-IETF-MPLS-ID-STD-03-MIB", "CISCO-IETF-MPLS-ID-STD-03-MIB"): "CISCO_IETF_MPLS_ID_STD_03_MIB.CISCOIETFMPLSIDSTD03MIB",
    ("CISCO-IETF-MPLS-ID-STD-03-MIB", "CISCO-IETF-MPLS-ID-STD-03-MIB"): "CISCO_IETF_MPLS_ID_STD_03_MIB.CISCOIETFMPLSIDSTD03MIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-IETF-MPLS-TE-EXT-STD-03-MIB", "CISCO-IETF-MPLS-TE-EXT-STD-03-MIB"): "CISCO_IETF_MPLS_TE_EXT_STD_03_MIB.CISCOIETFMPLSTEEXTSTD03MIB",
    ("CISCO-IETF-MPLS-TE-EXT-STD-03-MIB", "CISCO-IETF-MPLS-TE-EXT-STD-03-MIB"): "CISCO_IETF_MPLS_TE_EXT_STD_03_MIB.CISCOIETFMPLSTEEXTSTD03MIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-IETF-PW-ATM-MIB", "CISCO-IETF-PW-ATM-MIB"): "CISCO_IETF_PW_ATM_MIB.CISCOIETFPWATMMIB",
    ("CISCO-IETF-PW-ATM-MIB", "CISCO-IETF-PW-ATM-MIB"): "CISCO_IETF_PW_ATM_MIB.CISCOIETFPWATMMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-IETF-PW-ENET-MIB", "CISCO-IETF-PW-ENET-MIB"): "CISCO_IETF_PW_ENET_MIB.CISCOIETFPWENETMIB",
    ("CISCO-IETF-PW-ENET-MIB", "CISCO-IETF-PW-ENET-MIB"): "CISCO_IETF_PW_ENET_MIB.CISCOIETFPWENETMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-IETF-PW-MIB", "CISCO-IETF-PW-MIB"): "CISCO_IETF_PW_MIB.CISCOIETFPWMIB",
    ("CISCO-IETF-PW-MIB", "CISCO-IETF-PW-MIB"): "CISCO_IETF_PW_MIB.CISCOIETFPWMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-IETF-PW-MPLS-MIB", "CISCO-IETF-PW-MPLS-MIB"): "CISCO_IETF_PW_MPLS_MIB.CISCOIETFPWMPLSMIB",
    ("CISCO-IETF-PW-MPLS-MIB", "CISCO-IETF-PW-MPLS-MIB"): "CISCO_IETF_PW_MPLS_MIB.CISCOIETFPWMPLSMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-IETF-PW-TDM-MIB", "CISCO-IETF-PW-TDM-MIB"): "CISCO_IETF_PW_TDM_MIB.CISCOIETFPWTDMMIB",
    ("CISCO-IETF-PW-TDM-MIB", "CISCO-IETF-PW-TDM-MIB"): "CISCO_IETF_PW_TDM_MIB.CISCOIETFPWTDMMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-IF-EXTENSION-MIB", "CISCO-IF-EXTENSION-MIB"): "CISCO_IF_EXTENSION_MIB.CISCOIFEXTENSIONMIB",
    ("CISCO-IF-EXTENSION-MIB", "CISCO-IF-EXTENSION-MIB"): "CISCO_IF_EXTENSION_MIB.CISCOIFEXTENSIONMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-IGMP-FILTER-MIB", "CISCO-IGMP-FILTER-MIB"): "CISCO_IGMP_FILTER_MIB.CISCOIGMPFILTERMIB",
    ("CISCO-IGMP-FILTER-MIB", "CISCO-IGMP-FILTER-MIB"): "CISCO_IGMP_FILTER_MIB.CISCOIGMPFILTERMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-IMAGE-LICENSE-MGMT-MIB", "CISCO-IMAGE-LICENSE-MGMT-MIB"): "CISCO_IMAGE_LICENSE_MGMT_MIB.CISCOIMAGELICENSEMGMTMIB",
    ("CISCO-IMAGE-LICENSE-MGMT-MIB", "CISCO-IMAGE-LICENSE-MGMT-MIB"): "CISCO_IMAGE_LICENSE_MGMT_MIB.CISCOIMAGELICENSEMGMTMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-IMAGE-MIB", "CISCO-IMAGE-MIB"): "CISCO_IMAGE_MIB.CISCOIMAGEMIB",
    ("CISCO-IMAGE-MIB", "CISCO-IMAGE-MIB"): "CISCO_IMAGE_MIB.CISCOIMAGEMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-IPMROUTE-MIB", "CISCO-IPMROUTE-MIB"): "CISCO_IPMROUTE_MIB.CISCOIPMROUTEMIB",
    ("CISCO-IPMROUTE-MIB", "CISCO-IPMROUTE-MIB"): "CISCO_IPMROUTE_MIB.CISCOIPMROUTEMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-IPSEC-FLOW-MONITOR-MIB", "CISCO-IPSEC-FLOW-MONITOR-MIB"): "CISCO_IPSEC_FLOW_MONITOR_MIB.CISCOIPSECFLOWMONITORMIB",
    ("CISCO-IPSEC-FLOW-MONITOR-MIB", "CISCO-IPSEC-FLOW-MONITOR-MIB"): "CISCO_IPSEC_FLOW_MONITOR_MIB.CISCOIPSECFLOWMONITORMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-IPSEC-MIB", "CISCO-IPSEC-MIB"): "CISCO_IPSEC_MIB.CISCOIPSECMIB",
    ("CISCO-IPSEC-MIB", "CISCO-IPSEC-MIB"): "CISCO_IPSEC_MIB.CISCOIPSECMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-IPSEC-POLICY-MAP-MIB", "CISCO-IPSEC-POLICY-MAP-MIB"): "CISCO_IPSEC_POLICY_MAP_MIB.CISCOIPSECPOLICYMAPMIB",
    ("CISCO-IPSEC-POLICY-MAP-MIB", "CISCO-IPSEC-POLICY-MAP-MIB"): "CISCO_IPSEC_POLICY_MAP_MIB.CISCOIPSECPOLICYMAPMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-IPSLA-AUTOMEASURE-MIB", "CISCO-IPSLA-AUTOMEASURE-MIB"): "CISCO_IPSLA_AUTOMEASURE_MIB.CISCOIPSLAAUTOMEASUREMIB",
    ("CISCO-IPSLA-AUTOMEASURE-MIB", "CISCO-IPSLA-AUTOMEASURE-MIB"): "CISCO_IPSLA_AUTOMEASURE_MIB.CISCOIPSLAAUTOMEASUREMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-IPSLA-ECHO-MIB", "CISCO-IPSLA-ECHO-MIB"): "CISCO_IPSLA_ECHO_MIB.CISCOIPSLAECHOMIB",
    ("CISCO-IPSLA-ECHO-MIB", "CISCO-IPSLA-ECHO-MIB"): "CISCO_IPSLA_ECHO_MIB.CISCOIPSLAECHOMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-IPSLA-JITTER-MIB", "CISCO-IPSLA-JITTER-MIB"): "CISCO_IPSLA_JITTER_MIB.CISCOIPSLAJITTERMIB",
    ("CISCO-IPSLA-JITTER-MIB", "CISCO-IPSLA-JITTER-MIB"): "CISCO_IPSLA_JITTER_MIB.CISCOIPSLAJITTERMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-IP-LOCAL-POOL-MIB", "CISCO-IP-LOCAL-POOL-MIB"): "CISCO_IP_LOCAL_POOL_MIB.CISCOIPLOCALPOOLMIB",
    ("CISCO-IP-LOCAL-POOL-MIB", "CISCO-IP-LOCAL-POOL-MIB"): "CISCO_IP_LOCAL_POOL_MIB.CISCOIPLOCALPOOLMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-IP-TAP-MIB", "CISCO-IP-TAP-MIB"): "CISCO_IP_TAP_MIB.CISCOIPTAPMIB",
    ("CISCO-IP-TAP-MIB", "CISCO-IP-TAP-MIB"): "CISCO_IP_TAP_MIB.CISCOIPTAPMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-IP-URPF-MIB", "CISCO-IP-URPF-MIB"): "CISCO_IP_URPF_MIB.CISCOIPURPFMIB",
    ("CISCO-IP-URPF-MIB", "CISCO-IP-URPF-MIB"): "CISCO_IP_URPF_MIB.CISCOIPURPFMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-LICENSE-MGMT-MIB", "CISCO-LICENSE-MGMT-MIB"): "CISCO_LICENSE_MGMT_MIB.CISCOLICENSEMGMTMIB",
    ("CISCO-LICENSE-MGMT-MIB", "CISCO-LICENSE-MGMT-MIB"): "CISCO_LICENSE_MGMT_MIB.CISCOLICENSEMGMTMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-MEDIA-GATEWAY-MIB", "CISCO-MEDIA-GATEWAY-MIB"): "CISCO_MEDIA_GATEWAY_MIB.CISCOMEDIAGATEWAYMIB",
    ("CISCO-MEDIA-GATEWAY-MIB", "CISCO-MEDIA-GATEWAY-MIB"): "CISCO_MEDIA_GATEWAY_MIB.CISCOMEDIAGATEWAYMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-MPLS-LSR-EXT-STD-MIB", "CISCO-MPLS-LSR-EXT-STD-MIB"): "CISCO_MPLS_LSR_EXT_STD_MIB.CISCOMPLSLSREXTSTDMIB",
    ("CISCO-MPLS-LSR-EXT-STD-MIB", "CISCO-MPLS-LSR-EXT-STD-MIB"): "CISCO_MPLS_LSR_EXT_STD_MIB.CISCOMPLSLSREXTSTDMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-NBAR-PROTOCOL-DISCOVERY-MIB", "CISCO-NBAR-PROTOCOL-DISCOVERY-MIB"): "CISCO_NBAR_PROTOCOL_DISCOVERY_MIB.CISCONBARPROTOCOLDISCOVERYMIB",
    ("CISCO-NBAR-PROTOCOL-DISCOVERY-MIB", "CISCO-NBAR-PROTOCOL-DISCOVERY-MIB"): "CISCO_NBAR_PROTOCOL_DISCOVERY_MIB.CISCONBARPROTOCOLDISCOVERYMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-NETSYNC-MIB", "CISCO-NETSYNC-MIB"): "CISCO_NETSYNC_MIB.CISCONETSYNCMIB",
    ("CISCO-NETSYNC-MIB", "CISCO-NETSYNC-MIB"): "CISCO_NETSYNC_MIB.CISCONETSYNCMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-NTP-MIB", "CISCO-NTP-MIB"): "CISCO_NTP_MIB.CISCONTPMIB",
    ("CISCO-NTP-MIB", "CISCO-NTP-MIB"): "CISCO_NTP_MIB.CISCONTPMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-OSPF-MIB", "CISCO-OSPF-MIB"): "CISCO_OSPF_MIB.CISCOOSPFMIB",
    ("CISCO-OSPF-MIB", "CISCO-OSPF-MIB"): "CISCO_OSPF_MIB.CISCOOSPFMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-OSPF-TRAP-MIB", "CISCO-OSPF-TRAP-MIB"): "CISCO_OSPF_TRAP_MIB.CISCOOSPFTRAPMIB",
    ("CISCO-OSPF-TRAP-MIB", "CISCO-OSPF-TRAP-MIB"): "CISCO_OSPF_TRAP_MIB.CISCOOSPFTRAPMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-PIM-MIB", "CISCO-PIM-MIB"): "CISCO_PIM_MIB.CISCOPIMMIB",
    ("CISCO-PIM-MIB", "CISCO-PIM-MIB"): "CISCO_PIM_MIB.CISCOPIMMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-PING-MIB", "CISCO-PING-MIB"): "CISCO_PING_MIB.CISCOPINGMIB",
    ("CISCO-PING-MIB", "CISCO-PING-MIB"): "CISCO_PING_MIB.CISCOPINGMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-POWER-ETHERNET-EXT-MIB", "CISCO-POWER-ETHERNET-EXT-MIB"): "CISCO_POWER_ETHERNET_EXT_MIB.CISCOPOWERETHERNETEXTMIB",
    ("CISCO-POWER-ETHERNET-EXT-MIB", "CISCO-POWER-ETHERNET-EXT-MIB"): "CISCO_POWER_ETHERNET_EXT_MIB.CISCOPOWERETHERNETEXTMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-PROCESS-MIB", "CISCO-PROCESS-MIB"): "CISCO_PROCESS_MIB.CISCOPROCESSMIB",
    ("CISCO-PROCESS-MIB", "CISCO-PROCESS-MIB"): "CISCO_PROCESS_MIB.CISCOPROCESSMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-PTP-MIB", "CISCO-PTP-MIB"): "CISCO_PTP_MIB.CISCOPTPMIB",
    ("CISCO-PTP-MIB", "CISCO-PTP-MIB"): "CISCO_PTP_MIB.CISCOPTPMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-QOS-PIB-MIB", "CISCO-QOS-PIB-MIB"): "CISCO_QOS_PIB_MIB.CISCOQOSPIBMIB",
    ("CISCO-QOS-PIB-MIB", "CISCO-QOS-PIB-MIB"): "CISCO_QOS_PIB_MIB.CISCOQOSPIBMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-RADIUS-EXT-MIB", "CISCO-RADIUS-EXT-MIB"): "CISCO_RADIUS_EXT_MIB.CISCORADIUSEXTMIB",
    ("CISCO-RADIUS-EXT-MIB", "CISCO-RADIUS-EXT-MIB"): "CISCO_RADIUS_EXT_MIB.CISCORADIUSEXTMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-RF-MIB", "CISCO-RF-MIB"): "CISCO_RF_MIB.CISCORFMIB",
    ("CISCO-RF-MIB", "CISCO-RF-MIB"): "CISCO_RF_MIB.CISCORFMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-RTTMON-MIB", "CISCO-RTTMON-MIB"): "CISCO_RTTMON_MIB.CISCORTTMONMIB",
    ("CISCO-RTTMON-MIB", "CISCO-RTTMON-MIB"): "CISCO_RTTMON_MIB.CISCORTTMONMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-SESS-BORDER-CTRLR-CALL-STATS-MIB", "CISCO-SESS-BORDER-CTRLR-CALL-STATS-MIB"): "CISCO_SESS_BORDER_CTRLR_CALL_STATS_MIB.CISCOSESSBORDERCTRLRCALLSTATSMIB",
    ("CISCO-SESS-BORDER-CTRLR-CALL-STATS-MIB", "CISCO-SESS-BORDER-CTRLR-CALL-STATS-MIB"): "CISCO_SESS_BORDER_CTRLR_CALL_STATS_MIB.CISCOSESSBORDERCTRLRCALLSTATSMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-SESS-BORDER-CTRLR-STATS-MIB", "CISCO-SESS-BORDER-CTRLR-STATS-MIB"): "CISCO_SESS_BORDER_CTRLR_STATS_MIB.CISCOSESSBORDERCTRLRSTATSMIB",
    ("CISCO-SESS-BORDER-CTRLR-STATS-MIB", "CISCO-SESS-BORDER-CTRLR-STATS-MIB"): "CISCO_SESS_BORDER_CTRLR_STATS_MIB.CISCOSESSBORDERCTRLRSTATSMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-SIP-UA-MIB", "CISCO-SIP-UA-MIB"): "CISCO_SIP_UA_MIB.CISCOSIPUAMIB",
    ("CISCO-SIP-UA-MIB", "CISCO-SIP-UA-MIB"): "CISCO_SIP_UA_MIB.CISCOSIPUAMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-SONET-MIB", "CISCO-SONET-MIB"): "CISCO_SONET_MIB.CISCOSONETMIB",
    ("CISCO-SONET-MIB", "CISCO-SONET-MIB"): "CISCO_SONET_MIB.CISCOSONETMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-STP-EXTENSIONS-MIB", "CISCO-STP-EXTENSIONS-MIB"): "CISCO_STP_EXTENSIONS_MIB.CISCOSTPEXTENSIONSMIB",
    ("CISCO-STP-EXTENSIONS-MIB", "CISCO-STP-EXTENSIONS-MIB"): "CISCO_STP_EXTENSIONS_MIB.CISCOSTPEXTENSIONSMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-SUBSCRIBER-SESSION-MIB", "CISCO-SUBSCRIBER-SESSION-MIB"): "CISCO_SUBSCRIBER_SESSION_MIB.CISCOSUBSCRIBERSESSIONMIB",
    ("CISCO-SUBSCRIBER-SESSION-MIB", "CISCO-SUBSCRIBER-SESSION-MIB"): "CISCO_SUBSCRIBER_SESSION_MIB.CISCOSUBSCRIBERSESSIONMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-SYSLOG-MIB", "CISCO-SYSLOG-MIB"): "CISCO_SYSLOG_MIB.CISCOSYSLOGMIB",
    ("CISCO-SYSLOG-MIB", "CISCO-SYSLOG-MIB"): "CISCO_SYSLOG_MIB.CISCOSYSLOGMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-TAP2-MIB", "CISCO-TAP2-MIB"): "CISCO_TAP2_MIB.CISCOTAP2MIB",
    ("CISCO-TAP2-MIB", "CISCO-TAP2-MIB"): "CISCO_TAP2_MIB.CISCOTAP2MIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-UBE-MIB", "CISCO-UBE-MIB"): "CISCO_UBE_MIB.CISCOUBEMIB",
    ("CISCO-UBE-MIB", "CISCO-UBE-MIB"): "CISCO_UBE_MIB.CISCOUBEMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-UNIFIED-FIREWALL-MIB", "CISCO-UNIFIED-FIREWALL-MIB"): "CISCO_UNIFIED_FIREWALL_MIB.CISCOUNIFIEDFIREWALLMIB",
    ("CISCO-UNIFIED-FIREWALL-MIB", "CISCO-UNIFIED-FIREWALL-MIB"): "CISCO_UNIFIED_FIREWALL_MIB.CISCOUNIFIEDFIREWALLMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-VLAN-IFTABLE-RELATIONSHIP-MIB", "CISCO-VLAN-IFTABLE-RELATIONSHIP-MIB"): "CISCO_VLAN_IFTABLE_RELATIONSHIP_MIB.CISCOVLANIFTABLERELATIONSHIPMIB",
    ("CISCO-VLAN-IFTABLE-RELATIONSHIP-MIB", "CISCO-VLAN-IFTABLE-RELATIONSHIP-MIB"): "CISCO_VLAN_IFTABLE_RELATIONSHIP_MIB.CISCOVLANIFTABLERELATIONSHIPMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-VLAN-MEMBERSHIP-MIB", "CISCO-VLAN-MEMBERSHIP-MIB"): "CISCO_VLAN_MEMBERSHIP_MIB.CISCOVLANMEMBERSHIPMIB",
    ("CISCO-VLAN-MEMBERSHIP-MIB", "CISCO-VLAN-MEMBERSHIP-MIB"): "CISCO_VLAN_MEMBERSHIP_MIB.CISCOVLANMEMBERSHIPMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-VOICE-COMMON-DIAL-CONTROL-MIB", "CISCO-VOICE-COMMON-DIAL-CONTROL-MIB"): "CISCO_VOICE_COMMON_DIAL_CONTROL_MIB.CISCOVOICECOMMONDIALCONTROLMIB",
    ("CISCO-VOICE-COMMON-DIAL-CONTROL-MIB", "CISCO-VOICE-COMMON-DIAL-CONTROL-MIB"): "CISCO_VOICE_COMMON_DIAL_CONTROL_MIB.CISCOVOICECOMMONDIALCONTROLMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-VOICE-DIAL-CONTROL-MIB", "CISCO-VOICE-DIAL-CONTROL-MIB"): "CISCO_VOICE_DIAL_CONTROL_MIB.CISCOVOICEDIALCONTROLMIB",
    ("CISCO-VOICE-DIAL-CONTROL-MIB", "CISCO-VOICE-DIAL-CONTROL-MIB"): "CISCO_VOICE_DIAL_CONTROL_MIB.CISCOVOICEDIALCONTROLMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-VOICE-DNIS-MIB", "CISCO-VOICE-DNIS-MIB"): "CISCO_VOICE_DNIS_MIB.CISCOVOICEDNISMIB",
    ("CISCO-VOICE-DNIS-MIB", "CISCO-VOICE-DNIS-MIB"): "CISCO_VOICE_DNIS_MIB.CISCOVOICEDNISMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-VPDN-MGMT-MIB", "CISCO-VPDN-MGMT-MIB"): "CISCO_VPDN_MGMT_MIB.CISCOVPDNMGMTMIB",
    ("CISCO-VPDN-MGMT-MIB", "CISCO-VPDN-MGMT-MIB"): "CISCO_VPDN_MGMT_MIB.CISCOVPDNMGMTMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CISCO-VTP-MIB", "CISCO-VTP-MIB"): "CISCO_VTP_MIB.CISCOVTPMIB",
    ("CISCO-VTP-MIB", "CISCO-VTP-MIB"): "CISCO_VTP_MIB.CISCOVTPMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CLAB-DEF-MIB", "CLAB-DEF-MIB"): "CLAB_DEF_MIB.CLABDEFMIB",
    ("CLAB-DEF-MIB", "CLAB-DEF-MIB"): "CLAB_DEF_MIB.CLABDEFMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:CLAB-TOPO-MIB", "CLAB-TOPO-MIB"): "CLAB_TOPO_MIB.CLABTOPOMIB",
    ("CLAB-TOPO-MIB", "CLAB-TOPO-MIB"): "CLAB_TOPO_MIB.CLABTOPOMIB",
    ("http://cisco.com/ns/yang/Cisco-IOS-XE-aaa-oper", "aaa-data"): "Cisco_IOS_XE_aaa_oper.AaaData",
    ("Cisco-IOS-XE-aaa-oper", "aaa-data"): "Cisco_IOS_XE_aaa_oper.AaaData",
    ("http://cisco.com/ns/yang/Cisco-IOS-XE-acl-oper", "access-lists"): "Cisco_IOS_XE_acl_oper.AccessLists",
    ("Cisco-IOS-XE-acl-oper", "access-lists"): "Cisco_IOS_XE_acl_oper.AccessLists",
    ("http://cisco.com/ns/yang/Cisco-IOS-XE-arp-oper", "arp-data"): "Cisco_IOS_XE_arp_oper.ArpData",
    ("Cisco-IOS-XE-arp-oper", "arp-data"): "Cisco_IOS_XE_arp_oper.ArpData",
    ("http://cisco.com/ns/yang/Cisco-IOS-XE-bfd-oper", "bfd-state"): "Cisco_IOS_XE_bfd_oper.BfdState",
    ("Cisco-IOS-XE-bfd-oper", "bfd-state"): "Cisco_IOS_XE_bfd_oper.BfdState",
    ("http://cisco.com/ns/yang/Cisco-IOS-XE-bgp-oper", "bgp-state-data"): "Cisco_IOS_XE_bgp_oper.BgpStateData",
    ("Cisco-IOS-XE-bgp-oper", "bgp-state-data"): "Cisco_IOS_XE_bgp_oper.BgpStateData",
    ("http://cisco.com/ns/yang/Cisco-IOS-XE-boot-integrity-oper", "boot-integrity-oper-data"): "Cisco_IOS_XE_boot_integrity_oper.BootIntegrityOperData",
    ("Cisco-IOS-XE-boot-integrity-oper", "boot-integrity-oper-data"): "Cisco_IOS_XE_boot_integrity_oper.BootIntegrityOperData",
    ("http://cisco.com/ns/yang/Cisco-IOS-XE-breakout-port-oper", "breakout-port-oper-data"): "Cisco_IOS_XE_breakout_port_oper.BreakoutPortOperData",
    ("Cisco-IOS-XE-breakout-port-oper", "breakout-port-oper-data"): "Cisco_IOS_XE_breakout_port_oper.BreakoutPortOperData",
    ("http://cisco.com/ns/yang/Cisco-IOS-XE-bridge-oper", "bridge-instances"): "Cisco_IOS_XE_bridge_oper.BridgeInstances",
    ("Cisco-IOS-XE-bridge-oper", "bridge-instances"): "Cisco_IOS_XE_bridge_oper.BridgeInstances",
    ("http://cisco.com/ns/yang/Cisco-IOS-XE-cdp-oper", "cdp-neighbor-details"): "Cisco_IOS_XE_cdp_oper.CdpNeighborDetails",
    ("Cisco-IOS-XE-cdp-oper", "cdp-neighbor-details"): "Cisco_IOS_XE_cdp_oper.CdpNeighborDetails",
    ("http://cisco.com/ns/yang/Cisco-IOS-XE-cellwan-oper", "cellwan-oper-data"): "Cisco_IOS_XE_cellwan_oper.CellwanOperData",
    ("Cisco-IOS-XE-cellwan-oper", "cellwan-oper-data"): "Cisco_IOS_XE_cellwan_oper.CellwanOperData",
    ("http://cisco.com/ns/yang/Cisco-IOS-XE-cfm-oper", "cfm-statistics"): "Cisco_IOS_XE_cfm_oper.CfmStatistics",
    ("Cisco-IOS-XE-cfm-oper", "cfm-statistics"): "Cisco_IOS_XE_cfm_oper.CfmStatistics",
    ("http://cisco.com/ns/yang/Cisco-IOS-XE-checkpoint-archive-oper", "checkpoint-archives"): "Cisco_IOS_XE_checkpoint_archive_oper.CheckpointArchives",
    ("Cisco-IOS-XE-checkpoint-archive-oper", "checkpoint-archives"): "Cisco_IOS_XE_checkpoint_archive_oper.CheckpointArchives",
    ("http://cisco.com/ns/yang/Cisco-IOS-XE-controller-vdsl-oper", "vdsl-oper-data"): "Cisco_IOS_XE_controller_vdsl_oper.VdslOperData",
    ("Cisco-IOS-XE-controller-vdsl-oper", "vdsl-oper-data"): "Cisco_IOS_XE_controller_vdsl_oper.VdslOperData",
    ("http://cisco.com/ns/yang/Cisco-IOS-XE-device-hardware-oper", "device-hardware-data"): "Cisco_IOS_XE_device_hardware_oper.DeviceHardwareData",
    ("Cisco-IOS-XE-device-hardware-oper", "device-hardware-data"): "Cisco_IOS_XE_device_hardware_oper.DeviceHardwareData",
    ("http://cisco.com/ns/yang/Cisco-IOS-XE-dhcp-oper", "dhcp-oper-data"): "Cisco_IOS_XE_dhcp_oper.DhcpOperData",
    ("Cisco-IOS-XE-dhcp-oper", "dhcp-oper-data"): "Cisco_IOS_XE_dhcp_oper.DhcpOperData",
    ("http://cisco.com/ns/yang/Cisco-IOS-XE-diffserv-target-oper", "diffserv-interfaces-state"): "Cisco_IOS_XE_diffserv_target_oper.DiffservInterfacesState",
    ("Cisco-IOS-XE-diffserv-target-oper", "diffserv-interfaces-state"): "Cisco_IOS_XE_diffserv_target_oper.DiffservInterfacesState",
    ("http://cisco.com/ns/yang/Cisco-IOS-XE-efp-oper", "efp-stats"): "Cisco_IOS_XE_efp_oper.EfpStats",
    ("Cisco-IOS-XE-efp-oper", "efp-stats"): "Cisco_IOS_XE_efp_oper.EfpStats",
    ("http://cisco.com/ns/yang/Cisco-IOS-XE-environment-oper", "environment-sensors"): "Cisco_IOS_XE_environment_oper.EnvironmentSensors",
    ("Cisco-IOS-XE-environment-oper", "environment-sensors"): "Cisco_IOS_XE_environment_oper.EnvironmentSensors",
    ("http://cisco.com/ns/yang/Cisco-IOS-XE-fib-oper", "fib-oper-data"): "Cisco_IOS_XE_fib_oper.FibOperData",
    ("Cisco-IOS-XE-fib-oper", "fib-oper-data"): "Cisco_IOS_XE_fib_oper.FibOperData",
    ("http://cisco.com/ns/yang/Cisco-IOS-XE-flow-monitor-oper", "flow-monitors"): "Cisco_IOS_XE_flow_monitor_oper.FlowMonitors",
    ("Cisco-IOS-XE-flow-monitor-oper", "flow-monitors"): "Cisco_IOS_XE_flow_monitor_oper.FlowMonitors",
    ("http://cisco.com/ns/yang/Cisco-IOS-XE-fw-oper", "fw-oper-data"): "Cisco_IOS_XE_fw_oper.FwOperData",
    ("Cisco-IOS-XE-fw-oper", "fw-oper-data"): "Cisco_IOS_XE_fw_oper.FwOperData",
    ("http://cisco.com/ns/yang/Cisco-IOS-XE-interfaces-oper", "interfaces"): "Cisco_IOS_XE_interfaces_oper.Interfaces",
    ("Cisco-IOS-XE-interfaces-oper", "interfaces"): "Cisco_IOS_XE_interfaces_oper.Interfaces",
    ("http://cisco.com/ns/yang/Cisco-IOS-XE-ios-events-oper", "ios-events"): "Cisco_IOS_XE_ios_events_oper.IosEvents",
    ("Cisco-IOS-XE-ios-events-oper", "ios-events"): "Cisco_IOS_XE_ios_events_oper.IosEvents",
    ("http://cisco.com/ns/yang/Cisco-IOS-XE-ip-sla-oper", "ip-sla-stats"): "Cisco_IOS_XE_ip_sla_oper.IpSlaStats",
    ("Cisco-IOS-XE-ip-sla-oper", "ip-sla-stats"): "Cisco_IOS_XE_ip_sla_oper.IpSlaStats",
    ("http://cisco.com/ns/yang/Cisco-IOS-XE-ipv6-oper", "ipv6-data"): "Cisco_IOS_XE_ipv6_oper.Ipv6Data",
    ("Cisco-IOS-XE-ipv6-oper", "ipv6-data"): "Cisco_IOS_XE_ipv6_oper.Ipv6Data",
    ("http://cisco.com/ns/yang/Cisco-IOS-XE-linecard-oper", "linecard-oper-data"): "Cisco_IOS_XE_linecard_oper.LinecardOperData",
    ("Cisco-IOS-XE-linecard-oper", "linecard-oper-data"): "Cisco_IOS_XE_linecard_oper.LinecardOperData",
    ("http://cisco.com/ns/yang/Cisco-IOS-XE-lisp-oper", "lisp-state"): "Cisco_IOS_XE_lisp_oper.LispState",
    ("Cisco-IOS-XE-lisp-oper", "lisp-state"): "Cisco_IOS_XE_lisp_oper.LispState",
    ("http://cisco.com/ns/yang/Cisco-IOS-XE-lldp-oper", "lldp-entries"): "Cisco_IOS_XE_lldp_oper.LldpEntries",
    ("Cisco-IOS-XE-lldp-oper", "lldp-entries"): "Cisco_IOS_XE_lldp_oper.LldpEntries",
    ("http://cisco.com/ns/yang/Cisco-IOS-XE-mdt-cfg", "mdt-config-data"): "Cisco_IOS_XE_mdt_cfg.MdtConfigData",
    ("Cisco-IOS-XE-mdt-cfg", "mdt-config-data"): "Cisco_IOS_XE_mdt_cfg.MdtConfigData",
    ("http://cisco.com/ns/yang/Cisco-IOS-XE-mdt-oper", "mdt-oper-data"): "Cisco_IOS_XE_mdt_oper.MdtOperData",
    ("Cisco-IOS-XE-mdt-oper", "mdt-oper-data"): "Cisco_IOS_XE_mdt_oper.MdtOperData",
    ("http://cisco.com/ns/yang/Cisco-IOS-XE-memory-oper", "memory-statistics"): "Cisco_IOS_XE_memory_oper.MemoryStatistics",
    ("Cisco-IOS-XE-memory-oper", "memory-statistics"): "Cisco_IOS_XE_memory_oper.MemoryStatistics",
    ("http://cisco.com/ns/yang/Cisco-IOS-XE-mpls-forwarding-oper", "mpls-forwarding-oper-data"): "Cisco_IOS_XE_mpls_forwarding_oper.MplsForwardingOperData",
    ("Cisco-IOS-XE-mpls-forwarding-oper", "mpls-forwarding-oper-data"): "Cisco_IOS_XE_mpls_forwarding_oper.MplsForwardingOperData",
    ("http://cisco.com/ns/yang/Cisco-IOS-XE-nat-oper", "nat-data"): "Cisco_IOS_XE_nat_oper.NatData",
    ("Cisco-IOS-XE-nat-oper", "nat-data"): "Cisco_IOS_XE_nat_oper.NatData",
    ("http://cisco.com/ns/yang/Cisco-IOS-XE-native", "native"): "Cisco_IOS_XE_native.Native",
    ("Cisco-IOS-XE-native", "native"): "Cisco_IOS_XE_native.Native",
    ("http://cisco.com/ns/yang/Cisco-IOS-XE-ntp-oper", "ntp-oper-data"): "Cisco_IOS_XE_ntp_oper.NtpOperData",
    ("Cisco-IOS-XE-ntp-oper", "ntp-oper-data"): "Cisco_IOS_XE_ntp_oper.NtpOperData",
    ("http://cisco.com/ns/yang/Cisco-IOS-XE-ospf-oper", "ospf-oper-data"): "Cisco_IOS_XE_ospf_oper.OspfOperData",
    ("Cisco-IOS-XE-ospf-oper", "ospf-oper-data"): "Cisco_IOS_XE_ospf_oper.OspfOperData",
    ("http://cisco.com/ns/yang/Cisco-IOS-XE-platform-oper", "components"): "Cisco_IOS_XE_platform_oper.Components",
    ("Cisco-IOS-XE-platform-oper", "components"): "Cisco_IOS_XE_platform_oper.Components",
    ("http://cisco.com/ns/yang/Cisco-IOS-XE-platform-software-oper", "cisco-platform-software"): "Cisco_IOS_XE_platform_software_oper.CiscoPlatformSoftware",
    ("Cisco-IOS-XE-platform-software-oper", "cisco-platform-software"): "Cisco_IOS_XE_platform_software_oper.CiscoPlatformSoftware",
    ("http://cisco.com/ns/yang/Cisco-IOS-XE-poe-oper", "poe-oper-data"): "Cisco_IOS_XE_poe_oper.PoeOperData",
    ("Cisco-IOS-XE-poe-oper", "poe-oper-data"): "Cisco_IOS_XE_poe_oper.PoeOperData",
    ("http://cisco.com/ns/yang/Cisco-IOS-XE-ppp-oper", "ppp-data"): "Cisco_IOS_XE_ppp_oper.PppData",
    ("Cisco-IOS-XE-ppp-oper", "ppp-data"): "Cisco_IOS_XE_ppp_oper.PppData",
    ("http://cisco.com/ns/yang/Cisco-IOS-XE-process-cpu-oper", "cpu-usage"): "Cisco_IOS_XE_process_cpu_oper.CpuUsage",
    ("Cisco-IOS-XE-process-cpu-oper", "cpu-usage"): "Cisco_IOS_XE_process_cpu_oper.CpuUsage",
    ("http://cisco.com/ns/yang/Cisco-IOS-XE-process-memory-oper", "memory-usage-processes"): "Cisco_IOS_XE_process_memory_oper.MemoryUsageProcesses",
    ("Cisco-IOS-XE-process-memory-oper", "memory-usage-processes"): "Cisco_IOS_XE_process_memory_oper.MemoryUsageProcesses",
    ("http://cisco.com/ns/yang/Cisco-IOS-XE-spanning-tree-oper", "stp-details"): "Cisco_IOS_XE_spanning_tree_oper.StpDetails",
    ("Cisco-IOS-XE-spanning-tree-oper", "stp-details"): "Cisco_IOS_XE_spanning_tree_oper.StpDetails",
    ("http://cisco.com/ns/yang/Cisco-IOS-XE-tcam-oper", "tcam-details"): "Cisco_IOS_XE_tcam_oper.TcamDetails",
    ("Cisco-IOS-XE-tcam-oper", "tcam-details"): "Cisco_IOS_XE_tcam_oper.TcamDetails",
    ("http://cisco.com/ns/yang/Cisco-IOS-XE-transceiver-oper", "transceiver-oper-data"): "Cisco_IOS_XE_transceiver_oper.TransceiverOperData",
    ("Cisco-IOS-XE-transceiver-oper", "transceiver-oper-data"): "Cisco_IOS_XE_transceiver_oper.TransceiverOperData",
    ("http://cisco.com/ns/yang/Cisco-IOS-XE-trustsec-oper", "trustsec-state"): "Cisco_IOS_XE_trustsec_oper.TrustsecState",
    ("Cisco-IOS-XE-trustsec-oper", "trustsec-state"): "Cisco_IOS_XE_trustsec_oper.TrustsecState",
    ("http://cisco.com/ns/yang/Cisco-IOS-XE-utd-oper", "utd-oper-data"): "Cisco_IOS_XE_utd_oper.UtdOperData",
    ("Cisco-IOS-XE-utd-oper", "utd-oper-data"): "Cisco_IOS_XE_utd_oper.UtdOperData",
    ("http://cisco.com/ns/yang/Cisco-IOS-XE-virtual-service-cfg", "virtual-service-cfg-data"): "Cisco_IOS_XE_virtual_service_cfg.VirtualServiceCfgData",
    ("Cisco-IOS-XE-virtual-service-cfg", "virtual-service-cfg-data"): "Cisco_IOS_XE_virtual_service_cfg.VirtualServiceCfgData",
    ("http://cisco.com/ns/yang/Cisco-IOS-XE-virtual-service-oper", "virtual-services"): "Cisco_IOS_XE_virtual_service_oper.VirtualServices",
    ("Cisco-IOS-XE-virtual-service-oper", "virtual-services"): "Cisco_IOS_XE_virtual_service_oper.VirtualServices",
    ("http://cisco.com/ns/yang/Cisco-IOS-XE-vlan-oper", "vlans"): "Cisco_IOS_XE_vlan_oper.Vlans",
    ("Cisco-IOS-XE-vlan-oper", "vlans"): "Cisco_IOS_XE_vlan_oper.Vlans",
    ("http://cisco.com/ns/yang/Cisco-IOS-XE-vrrp-oper", "vrrp-oper-data"): "Cisco_IOS_XE_vrrp_oper.VrrpOperData",
    ("Cisco-IOS-XE-vrrp-oper", "vrrp-oper-data"): "Cisco_IOS_XE_vrrp_oper.VrrpOperData",
    ("urn:ietf:params:xml:ns:yang:smiv2:DIAL-CONTROL-MIB", "DIAL-CONTROL-MIB"): "DIAL_CONTROL_MIB.DIALCONTROLMIB",
    ("DIAL-CONTROL-MIB", "DIAL-CONTROL-MIB"): "DIAL_CONTROL_MIB.DIALCONTROLMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:DIFFSERV-MIB", "DIFFSERV-MIB"): "DIFFSERV_MIB.DIFFSERVMIB",
    ("DIFFSERV-MIB", "DIFFSERV-MIB"): "DIFFSERV_MIB.DIFFSERVMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:DISMAN-EVENT-MIB", "DISMAN-EVENT-MIB"): "DISMAN_EVENT_MIB.DISMANEVENTMIB",
    ("DISMAN-EVENT-MIB", "DISMAN-EVENT-MIB"): "DISMAN_EVENT_MIB.DISMANEVENTMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:DISMAN-EXPRESSION-MIB", "DISMAN-EXPRESSION-MIB"): "DISMAN_EXPRESSION_MIB.DISMANEXPRESSIONMIB",
    ("DISMAN-EXPRESSION-MIB", "DISMAN-EXPRESSION-MIB"): "DISMAN_EXPRESSION_MIB.DISMANEXPRESSIONMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:DOCS-CABLE-DEVICE-MIB", "DOCS-CABLE-DEVICE-MIB"): "DOCS_CABLE_DEVICE_MIB.DOCSCABLEDEVICEMIB",
    ("DOCS-CABLE-DEVICE-MIB", "DOCS-CABLE-DEVICE-MIB"): "DOCS_CABLE_DEVICE_MIB.DOCSCABLEDEVICEMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:DOCS-IETF-BPI2-MIB", "DOCS-IETF-BPI2-MIB"): "DOCS_IETF_BPI2_MIB.DOCSIETFBPI2MIB",
    ("DOCS-IETF-BPI2-MIB", "DOCS-IETF-BPI2-MIB"): "DOCS_IETF_BPI2_MIB.DOCSIETFBPI2MIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:DOCS-IF3-MIB", "DOCS-IF3-MIB"): "DOCS_IF3_MIB.DOCSIF3MIB",
    ("DOCS-IF3-MIB", "DOCS-IF3-MIB"): "DOCS_IF3_MIB.DOCSIF3MIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:DOCS-IF-MIB", "DOCS-IF-MIB"): "DOCS_IF_MIB.DOCSIFMIB",
    ("DOCS-IF-MIB", "DOCS-IF-MIB"): "DOCS_IF_MIB.DOCSIFMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:DOCS-L2VPN-MIB", "DOCS-L2VPN-MIB"): "DOCS_L2VPN_MIB.DOCSL2VPNMIB",
    ("DOCS-L2VPN-MIB", "DOCS-L2VPN-MIB"): "DOCS_L2VPN_MIB.DOCSL2VPNMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:DOCS-QOS-MIB", "DOCS-QOS-MIB"): "DOCS_QOS_MIB.DOCSQOSMIB",
    ("DOCS-QOS-MIB", "DOCS-QOS-MIB"): "DOCS_QOS_MIB.DOCSQOSMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:DOCS-SUBMGT3-MIB", "DOCS-SUBMGT3-MIB"): "DOCS_SUBMGT3_MIB.DOCSSUBMGT3MIB",
    ("DOCS-SUBMGT3-MIB", "DOCS-SUBMGT3-MIB"): "DOCS_SUBMGT3_MIB.DOCSSUBMGT3MIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:DRAFT-MSDP-MIB", "DRAFT-MSDP-MIB"): "DRAFT_MSDP_MIB.DRAFTMSDPMIB",
    ("DRAFT-MSDP-MIB", "DRAFT-MSDP-MIB"): "DRAFT_MSDP_MIB.DRAFTMSDPMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:DS1-MIB", "DS1-MIB"): "DS1_MIB.DS1MIB",
    ("DS1-MIB", "DS1-MIB"): "DS1_MIB.DS1MIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:DS3-MIB", "DS3-MIB"): "DS3_MIB.DS3MIB",
    ("DS3-MIB", "DS3-MIB"): "DS3_MIB.DS3MIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:ENTITY-MIB", "ENTITY-MIB"): "ENTITY_MIB.ENTITYMIB",
    ("ENTITY-MIB", "ENTITY-MIB"): "ENTITY_MIB.ENTITYMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:ENTITY-SENSOR-MIB", "ENTITY-SENSOR-MIB"): "ENTITY_SENSOR_MIB.ENTITYSENSORMIB",
    ("ENTITY-SENSOR-MIB", "ENTITY-SENSOR-MIB"): "ENTITY_SENSOR_MIB.ENTITYSENSORMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:ENTITY-STATE-MIB", "ENTITY-STATE-MIB"): "ENTITY_STATE_MIB.ENTITYSTATEMIB",
    ("ENTITY-STATE-MIB", "ENTITY-STATE-MIB"): "ENTITY_STATE_MIB.ENTITYSTATEMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:ETHER-WIS", "ETHER-WIS"): "ETHER_WIS.ETHERWIS",
    ("ETHER-WIS", "ETHER-WIS"): "ETHER_WIS.ETHERWIS",
    ("urn:ietf:params:xml:ns:yang:smiv2:EXPRESSION-MIB", "EXPRESSION-MIB"): "EXPRESSION_MIB.EXPRESSIONMIB",
    ("EXPRESSION-MIB", "EXPRESSION-MIB"): "EXPRESSION_MIB.EXPRESSIONMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:EtherLike-MIB", "EtherLike-MIB"): "EtherLike_MIB.EtherLikeMIB",
    ("EtherLike-MIB", "EtherLike-MIB"): "EtherLike_MIB.EtherLikeMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:FRAME-RELAY-DTE-MIB", "FRAME-RELAY-DTE-MIB"): "FRAME_RELAY_DTE_MIB.FRAMERELAYDTEMIB",
    ("FRAME-RELAY-DTE-MIB", "FRAME-RELAY-DTE-MIB"): "FRAME_RELAY_DTE_MIB.FRAMERELAYDTEMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:IF-MIB", "IF-MIB"): "IF_MIB.IFMIB",
    ("IF-MIB", "IF-MIB"): "IF_MIB.IFMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:IGMP-STD-MIB", "IGMP-STD-MIB"): "IGMP_STD_MIB.IGMPSTDMIB",
    ("IGMP-STD-MIB", "IGMP-STD-MIB"): "IGMP_STD_MIB.IGMPSTDMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:INTEGRATED-SERVICES-MIB", "INTEGRATED-SERVICES-MIB"): "INTEGRATED_SERVICES_MIB.INTEGRATEDSERVICESMIB",
    ("INTEGRATED-SERVICES-MIB", "INTEGRATED-SERVICES-MIB"): "INTEGRATED_SERVICES_MIB.INTEGRATEDSERVICESMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:INT-SERV-MIB", "INT-SERV-MIB"): "INT_SERV_MIB.INTSERVMIB",
    ("INT-SERV-MIB", "INT-SERV-MIB"): "INT_SERV_MIB.INTSERVMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:IPMROUTE-STD-MIB", "IPMROUTE-STD-MIB"): "IPMROUTE_STD_MIB.IPMROUTESTDMIB",
    ("IPMROUTE-STD-MIB", "IPMROUTE-STD-MIB"): "IPMROUTE_STD_MIB.IPMROUTESTDMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:IP-FORWARD-MIB", "IP-FORWARD-MIB"): "IP_FORWARD_MIB.IPFORWARDMIB",
    ("IP-FORWARD-MIB", "IP-FORWARD-MIB"): "IP_FORWARD_MIB.IPFORWARDMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:IP-MIB", "IP-MIB"): "IP_MIB.IPMIB",
    ("IP-MIB", "IP-MIB"): "IP_MIB.IPMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:LLDP-MIB", "LLDP-MIB"): "LLDP_MIB.LLDPMIB",
    ("LLDP-MIB", "LLDP-MIB"): "LLDP_MIB.LLDPMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:MPLS-L3VPN-STD-MIB", "MPLS-L3VPN-STD-MIB"): "MPLS_L3VPN_STD_MIB.MPLSL3VPNSTDMIB",
    ("MPLS-L3VPN-STD-MIB", "MPLS-L3VPN-STD-MIB"): "MPLS_L3VPN_STD_MIB.MPLSL3VPNSTDMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:MPLS-LDP-GENERIC-STD-MIB", "MPLS-LDP-GENERIC-STD-MIB"): "MPLS_LDP_GENERIC_STD_MIB.MPLSLDPGENERICSTDMIB",
    ("MPLS-LDP-GENERIC-STD-MIB", "MPLS-LDP-GENERIC-STD-MIB"): "MPLS_LDP_GENERIC_STD_MIB.MPLSLDPGENERICSTDMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:MPLS-LDP-STD-MIB", "MPLS-LDP-STD-MIB"): "MPLS_LDP_STD_MIB.MPLSLDPSTDMIB",
    ("MPLS-LDP-STD-MIB", "MPLS-LDP-STD-MIB"): "MPLS_LDP_STD_MIB.MPLSLDPSTDMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:MPLS-LSR-STD-MIB", "MPLS-LSR-STD-MIB"): "MPLS_LSR_STD_MIB.MPLSLSRSTDMIB",
    ("MPLS-LSR-STD-MIB", "MPLS-LSR-STD-MIB"): "MPLS_LSR_STD_MIB.MPLSLSRSTDMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:MPLS-TE-STD-MIB", "MPLS-TE-STD-MIB"): "MPLS_TE_STD_MIB.MPLSTESTDMIB",
    ("MPLS-TE-STD-MIB", "MPLS-TE-STD-MIB"): "MPLS_TE_STD_MIB.MPLSTESTDMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:MPLS-VPN-MIB", "MPLS-VPN-MIB"): "MPLS_VPN_MIB.MPLSVPNMIB",
    ("MPLS-VPN-MIB", "MPLS-VPN-MIB"): "MPLS_VPN_MIB.MPLSVPNMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:NHRP-MIB", "NHRP-MIB"): "NHRP_MIB.NHRPMIB",
    ("NHRP-MIB", "NHRP-MIB"): "NHRP_MIB.NHRPMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:NOTIFICATION-LOG-MIB", "NOTIFICATION-LOG-MIB"): "NOTIFICATION_LOG_MIB.NOTIFICATIONLOGMIB",
    ("NOTIFICATION-LOG-MIB", "NOTIFICATION-LOG-MIB"): "NOTIFICATION_LOG_MIB.NOTIFICATIONLOGMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:OLD-CISCO-INTERFACES-MIB", "OLD-CISCO-INTERFACES-MIB"): "OLD_CISCO_INTERFACES_MIB.OLDCISCOINTERFACESMIB",
    ("OLD-CISCO-INTERFACES-MIB", "OLD-CISCO-INTERFACES-MIB"): "OLD_CISCO_INTERFACES_MIB.OLDCISCOINTERFACESMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:OSPF-MIB", "OSPF-MIB"): "OSPF_MIB.OSPFMIB",
    ("OSPF-MIB", "OSPF-MIB"): "OSPF_MIB.OSPFMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:OSPF-TRAP-MIB", "OSPF-TRAP-MIB"): "OSPF_TRAP_MIB.OSPFTRAPMIB",
    ("OSPF-TRAP-MIB", "OSPF-TRAP-MIB"): "OSPF_TRAP_MIB.OSPFTRAPMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:PIM-MIB", "PIM-MIB"): "PIM_MIB.PIMMIB",
    ("PIM-MIB", "PIM-MIB"): "PIM_MIB.PIMMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:POWER-ETHERNET-MIB", "POWER-ETHERNET-MIB"): "POWER_ETHERNET_MIB.POWERETHERNETMIB",
    ("POWER-ETHERNET-MIB", "POWER-ETHERNET-MIB"): "POWER_ETHERNET_MIB.POWERETHERNETMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:P-BRIDGE-MIB", "P-BRIDGE-MIB"): "P_BRIDGE_MIB.PBRIDGEMIB",
    ("P-BRIDGE-MIB", "P-BRIDGE-MIB"): "P_BRIDGE_MIB.PBRIDGEMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:Q-BRIDGE-MIB", "Q-BRIDGE-MIB"): "Q_BRIDGE_MIB.QBRIDGEMIB",
    ("Q-BRIDGE-MIB", "Q-BRIDGE-MIB"): "Q_BRIDGE_MIB.QBRIDGEMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:RFC1213-MIB", "RFC1213-MIB"): "RFC1213_MIB.RFC1213MIB",
    ("RFC1213-MIB", "RFC1213-MIB"): "RFC1213_MIB.RFC1213MIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:RFC1315-MIB", "RFC1315-MIB"): "RFC1315_MIB.RFC1315MIB",
    ("RFC1315-MIB", "RFC1315-MIB"): "RFC1315_MIB.RFC1315MIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:RMON2-MIB", "RMON2-MIB"): "RMON2_MIB.RMON2MIB",
    ("RMON2-MIB", "RMON2-MIB"): "RMON2_MIB.RMON2MIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:RMON-MIB", "RMON-MIB"): "RMON_MIB.RMONMIB",
    ("RMON-MIB", "RMON-MIB"): "RMON_MIB.RMONMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:RSVP-MIB", "RSVP-MIB"): "RSVP_MIB.RSVPMIB",
    ("RSVP-MIB", "RSVP-MIB"): "RSVP_MIB.RSVPMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:SNMP-FRAMEWORK-MIB", "SNMP-FRAMEWORK-MIB"): "SNMP_FRAMEWORK_MIB.SNMPFRAMEWORKMIB",
    ("SNMP-FRAMEWORK-MIB", "SNMP-FRAMEWORK-MIB"): "SNMP_FRAMEWORK_MIB.SNMPFRAMEWORKMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:SNMP-PROXY-MIB", "SNMP-PROXY-MIB"): "SNMP_PROXY_MIB.SNMPPROXYMIB",
    ("SNMP-PROXY-MIB", "SNMP-PROXY-MIB"): "SNMP_PROXY_MIB.SNMPPROXYMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:SNMP-TARGET-MIB", "SNMP-TARGET-MIB"): "SNMP_TARGET_MIB.SNMPTARGETMIB",
    ("SNMP-TARGET-MIB", "SNMP-TARGET-MIB"): "SNMP_TARGET_MIB.SNMPTARGETMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:SNMPv2-MIB", "SNMPv2-MIB"): "SNMPv2_MIB.SNMPv2MIB",
    ("SNMPv2-MIB", "SNMPv2-MIB"): "SNMPv2_MIB.SNMPv2MIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:SONET-MIB", "SONET-MIB"): "SONET_MIB.SONETMIB",
    ("SONET-MIB", "SONET-MIB"): "SONET_MIB.SONETMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:TCP-MIB", "TCP-MIB"): "TCP_MIB.TCPMIB",
    ("TCP-MIB", "TCP-MIB"): "TCP_MIB.TCPMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:TOKENRING-MIB", "TOKENRING-MIB"): "TOKENRING_MIB.TOKENRINGMIB",
    ("TOKENRING-MIB", "TOKENRING-MIB"): "TOKENRING_MIB.TOKENRINGMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:TOKEN-RING-RMON-MIB", "TOKEN-RING-RMON-MIB"): "TOKEN_RING_RMON_MIB.TOKENRINGRMONMIB",
    ("TOKEN-RING-RMON-MIB", "TOKEN-RING-RMON-MIB"): "TOKEN_RING_RMON_MIB.TOKENRINGRMONMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:TUNNEL-MIB", "TUNNEL-MIB"): "TUNNEL_MIB.TUNNELMIB",
    ("TUNNEL-MIB", "TUNNEL-MIB"): "TUNNEL_MIB.TUNNELMIB",
    ("urn:ietf:params:xml:ns:yang:smiv2:UDP-MIB", "UDP-MIB"): "UDP_MIB.UDPMIB",
    ("UDP-MIB", "UDP-MIB"): "UDP_MIB.UDPMIB",
    ("urn:cisco:params:xml:ns:yang:cisco-bridge-domain", "bridge-domain-config"): "cisco_bridge_domain.BridgeDomainConfig",
    ("cisco-bridge-domain", "bridge-domain-config"): "cisco_bridge_domain.BridgeDomainConfig",
    ("urn:cisco:params:xml:ns:yang:cisco-bridge-domain", "bridge-domain-state"): "cisco_bridge_domain.BridgeDomainState",
    ("cisco-bridge-domain", "bridge-domain-state"): "cisco_bridge_domain.BridgeDomainState",
    ("urn:cisco:params:xml:ns:yang:pw", "pseudowire-config"): "cisco_pw.PseudowireConfig",
    ("cisco-pw", "pseudowire-config"): "cisco_pw.PseudowireConfig",
    ("urn:cisco:params:xml:ns:yang:pw", "pseudowire-state"): "cisco_pw.PseudowireState",
    ("cisco-pw", "pseudowire-state"): "cisco_pw.PseudowireState",
    ("http://cisco.com/yang/cisco-self-mgmt", "netconf-yang"): "cisco_self_mgmt.NetconfYang",
    ("cisco-self-mgmt", "netconf-yang"): "cisco_self_mgmt.NetconfYang",
    ("http://cisco.com/ns/yang/cisco-smart-license", "licensing"): "cisco_smart_license.Licensing",
    ("cisco-smart-license", "licensing"): "cisco_smart_license.Licensing",
    ("urn:ietf:params:xml:ns:yang:common-mpls-static", "mpls-static"): "common_mpls_static.MplsStatic",
    ("common-mpls-static", "mpls-static"): "common_mpls_static.MplsStatic",
    ("urn:ietf:params:xml:ns:yang:nvo", "nvo-instances"): "nvo.NvoInstances",
    ("nvo", "nvo-instances"): "nvo.NvoInstances",
    ("http://tail-f.com/yang/confd-monitoring", "confd-state"): "tailf_confd_monitoring.ConfdState",
    ("tailf-confd-monitoring", "confd-state"): "tailf_confd_monitoring.ConfdState",
}

NAMESPACE_LOOKUP = {
    "ATM-FORUM-TC-MIB": "urn:ietf:params:xml:ns:yang:smiv2:ATM-FORUM-TC-MIB",
    "ATM-MIB": "urn:ietf:params:xml:ns:yang:smiv2:ATM-MIB",
    "ATM-TC-MIB": "urn:ietf:params:xml:ns:yang:smiv2:ATM-TC-MIB",
    "BGP4-MIB": "urn:ietf:params:xml:ns:yang:smiv2:BGP4-MIB",
    "BRIDGE-MIB": "urn:ietf:params:xml:ns:yang:smiv2:BRIDGE-MIB",
    "CISCO-AAA-SERVER-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-AAA-SERVER-MIB",
    "CISCO-AAA-SESSION-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-AAA-SESSION-MIB",
    "CISCO-AAL5-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-AAL5-MIB",
    "CISCO-ATM-EXT-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-ATM-EXT-MIB",
    "CISCO-ATM-PVCTRAP-EXTN-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-ATM-PVCTRAP-EXTN-MIB",
    "CISCO-ATM-QOS-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-ATM-QOS-MIB",
    "CISCO-BGP4-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-BGP4-MIB",
    "CISCO-BGP-POLICY-ACCOUNTING-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-BGP-POLICY-ACCOUNTING-MIB",
    "CISCO-BULK-FILE-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-BULK-FILE-MIB",
    "CISCO-CABLE-SPECTRUM-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-CABLE-SPECTRUM-MIB",
    "CISCO-CABLE-WIDEBAND-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-CABLE-WIDEBAND-MIB",
    "CISCO-CBP-TARGET-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-CBP-TARGET-MIB",
    "CISCO-CBP-TARGET-TC-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-CBP-TARGET-TC-MIB",
    "CISCO-CBP-TC-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-CBP-TC-MIB",
    "CISCO-CDP-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-CDP-MIB",
    "CISCO-CEF-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-CEF-MIB",
    "CISCO-CEF-TC": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-CEF-TC",
    "CISCO-CONFIG-COPY-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-CONFIG-COPY-MIB",
    "CISCO-CONFIG-MAN-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-CONFIG-MAN-MIB",
    "CISCO-CONTEXT-MAPPING-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-CONTEXT-MAPPING-MIB",
    "CISCO-DATA-COLLECTION-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-DATA-COLLECTION-MIB",
    "CISCO-DIAL-CONTROL-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-DIAL-CONTROL-MIB",
    "CISCO-DOCS-EXT-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-DOCS-EXT-MIB",
    "CISCO-DOT3-OAM-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-DOT3-OAM-MIB",
    "CISCO-DYNAMIC-TEMPLATE-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-DYNAMIC-TEMPLATE-MIB",
    "CISCO-DYNAMIC-TEMPLATE-TC-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-DYNAMIC-TEMPLATE-TC-MIB",
    "CISCO-EIGRP-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-EIGRP-MIB",
    "CISCO-EMBEDDED-EVENT-MGR-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-EMBEDDED-EVENT-MGR-MIB",
    "CISCO-ENHANCED-MEMPOOL-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-ENHANCED-MEMPOOL-MIB",
    "CISCO-ENTITY-ALARM-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-ENTITY-ALARM-MIB",
    "CISCO-ENTITY-EXT-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-ENTITY-EXT-MIB",
    "CISCO-ENTITY-FRU-CONTROL-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-ENTITY-FRU-CONTROL-MIB",
    "CISCO-ENTITY-QFP-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-ENTITY-QFP-MIB",
    "CISCO-ENTITY-SENSOR-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-ENTITY-SENSOR-MIB",
    "CISCO-ENTITY-VENDORTYPE-OID-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-ENTITY-VENDORTYPE-OID-MIB",
    "CISCO-ENVMON-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-ENVMON-MIB",
    "CISCO-ETHERLIKE-EXT-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-ETHERLIKE-EXT-MIB",
    "CISCO-ETHER-CFM-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-ETHER-CFM-MIB",
    "CISCO-FIREWALL-TC": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-FIREWALL-TC",
    "CISCO-FLASH-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-FLASH-MIB",
    "CISCO-FTP-CLIENT-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-FTP-CLIENT-MIB",
    "CISCO-HSRP-EXT-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-HSRP-EXT-MIB",
    "CISCO-HSRP-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-HSRP-MIB",
    "CISCO-IETF-ATM2-PVCTRAP-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-IETF-ATM2-PVCTRAP-MIB",
    "CISCO-IETF-ATM2-PVCTRAP-MIB-EXTN": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-IETF-ATM2-PVCTRAP-MIB-EXTN",
    "CISCO-IETF-BFD-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-IETF-BFD-MIB",
    "CISCO-IETF-FRR-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-IETF-FRR-MIB",
    "CISCO-IETF-ISIS-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-IETF-ISIS-MIB",
    "CISCO-IETF-MPLS-ID-STD-03-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-IETF-MPLS-ID-STD-03-MIB",
    "CISCO-IETF-MPLS-TE-EXT-STD-03-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-IETF-MPLS-TE-EXT-STD-03-MIB",
    "CISCO-IETF-PW-ATM-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-IETF-PW-ATM-MIB",
    "CISCO-IETF-PW-ENET-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-IETF-PW-ENET-MIB",
    "CISCO-IETF-PW-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-IETF-PW-MIB",
    "CISCO-IETF-PW-MPLS-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-IETF-PW-MPLS-MIB",
    "CISCO-IETF-PW-TC-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-IETF-PW-TC-MIB",
    "CISCO-IETF-PW-TDM-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-IETF-PW-TDM-MIB",
    "CISCO-IF-EXTENSION-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-IF-EXTENSION-MIB",
    "CISCO-IGMP-FILTER-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-IGMP-FILTER-MIB",
    "CISCO-IMAGE-LICENSE-MGMT-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-IMAGE-LICENSE-MGMT-MIB",
    "CISCO-IMAGE-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-IMAGE-MIB",
    "CISCO-IPMROUTE-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-IPMROUTE-MIB",
    "CISCO-IPSEC-FLOW-MONITOR-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-IPSEC-FLOW-MONITOR-MIB",
    "CISCO-IPSEC-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-IPSEC-MIB",
    "CISCO-IPSEC-POLICY-MAP-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-IPSEC-POLICY-MAP-MIB",
    "CISCO-IPSLA-AUTOMEASURE-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-IPSLA-AUTOMEASURE-MIB",
    "CISCO-IPSLA-ECHO-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-IPSLA-ECHO-MIB",
    "CISCO-IPSLA-JITTER-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-IPSLA-JITTER-MIB",
    "CISCO-IPSLA-TC-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-IPSLA-TC-MIB",
    "CISCO-IP-LOCAL-POOL-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-IP-LOCAL-POOL-MIB",
    "CISCO-IP-TAP-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-IP-TAP-MIB",
    "CISCO-IP-URPF-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-IP-URPF-MIB",
    "CISCO-LICENSE-MGMT-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-LICENSE-MGMT-MIB",
    "CISCO-MEDIA-GATEWAY-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-MEDIA-GATEWAY-MIB",
    "CISCO-MPLS-LSR-EXT-STD-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-MPLS-LSR-EXT-STD-MIB",
    "CISCO-MPLS-TC-EXT-STD-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-MPLS-TC-EXT-STD-MIB",
    "CISCO-NBAR-PROTOCOL-DISCOVERY-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-NBAR-PROTOCOL-DISCOVERY-MIB",
    "CISCO-NETSYNC-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-NETSYNC-MIB",
    "CISCO-NTP-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-NTP-MIB",
    "CISCO-OSPF-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-OSPF-MIB",
    "CISCO-OSPF-TRAP-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-OSPF-TRAP-MIB",
    "CISCO-PIM-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-PIM-MIB",
    "CISCO-PING-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-PING-MIB",
    "CISCO-POWER-ETHERNET-EXT-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-POWER-ETHERNET-EXT-MIB",
    "CISCO-PROCESS-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-PROCESS-MIB",
    "CISCO-PRODUCTS-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-PRODUCTS-MIB",
    "CISCO-PTP-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-PTP-MIB",
    "CISCO-QOS-PIB-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-QOS-PIB-MIB",
    "CISCO-RADIUS-EXT-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-RADIUS-EXT-MIB",
    "CISCO-RF-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-RF-MIB",
    "CISCO-RTTMON-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-RTTMON-MIB",
    "CISCO-RTTMON-TC-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-RTTMON-TC-MIB",
    "CISCO-SESS-BORDER-CTRLR-CALL-STATS-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-SESS-BORDER-CTRLR-CALL-STATS-MIB",
    "CISCO-SESS-BORDER-CTRLR-STATS-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-SESS-BORDER-CTRLR-STATS-MIB",
    "CISCO-SIP-UA-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-SIP-UA-MIB",
    "CISCO-SMI": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-SMI",
    "CISCO-SONET-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-SONET-MIB",
    "CISCO-STP-EXTENSIONS-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-STP-EXTENSIONS-MIB",
    "CISCO-ST-TC": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-ST-TC",
    "CISCO-SUBSCRIBER-IDENTITY-TC-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-SUBSCRIBER-IDENTITY-TC-MIB",
    "CISCO-SUBSCRIBER-SESSION-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-SUBSCRIBER-SESSION-MIB",
    "CISCO-SUBSCRIBER-SESSION-TC-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-SUBSCRIBER-SESSION-TC-MIB",
    "CISCO-SYSLOG-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-SYSLOG-MIB",
    "CISCO-TAP2-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-TAP2-MIB",
    "CISCO-TC": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-TC",
    "CISCO-UBE-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-UBE-MIB",
    "CISCO-UNIFIED-FIREWALL-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-UNIFIED-FIREWALL-MIB",
    "CISCO-VLAN-IFTABLE-RELATIONSHIP-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-VLAN-IFTABLE-RELATIONSHIP-MIB",
    "CISCO-VLAN-MEMBERSHIP-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-VLAN-MEMBERSHIP-MIB",
    "CISCO-VOICE-COMMON-DIAL-CONTROL-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-VOICE-COMMON-DIAL-CONTROL-MIB",
    "CISCO-VOICE-DIAL-CONTROL-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-VOICE-DIAL-CONTROL-MIB",
    "CISCO-VOICE-DNIS-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-VOICE-DNIS-MIB",
    "CISCO-VPDN-MGMT-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-VPDN-MGMT-MIB",
    "CISCO-VTP-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CISCO-VTP-MIB",
    "CLAB-DEF-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CLAB-DEF-MIB",
    "CLAB-TOPO-MIB": "urn:ietf:params:xml:ns:yang:smiv2:CLAB-TOPO-MIB",
    "Cisco-IOS-XE-aaa": "http://cisco.com/ns/yang/Cisco-IOS-XE-aaa",
    "Cisco-IOS-XE-aaa-oper": "http://cisco.com/ns/yang/Cisco-IOS-XE-aaa-oper",
    "Cisco-IOS-XE-acl": "http://cisco.com/ns/yang/Cisco-IOS-XE-acl",
    "Cisco-IOS-XE-acl-oper": "http://cisco.com/ns/yang/Cisco-IOS-XE-acl-oper",
    "Cisco-IOS-XE-arp": "http://cisco.com/ns/yang/Cisco-IOS-XE-arp",
    "Cisco-IOS-XE-arp-oper": "http://cisco.com/ns/yang/Cisco-IOS-XE-arp-oper",
    "Cisco-IOS-XE-atm": "http://cisco.com/ns/yang/Cisco-IOS-XE-atm",
    "Cisco-IOS-XE-avb": "http://cisco.com/ns/yang/Cisco-IOS-XE-avb",
    "Cisco-IOS-XE-bba-group": "http://cisco.com/ns/yang/Cisco-IOS-XE-bba-group",
    "Cisco-IOS-XE-bfd": "http://cisco.com/ns/yang/Cisco-IOS-XE-bfd",
    "Cisco-IOS-XE-bfd-oper": "http://cisco.com/ns/yang/Cisco-IOS-XE-bfd-oper",
    "Cisco-IOS-XE-bgp": "http://cisco.com/ns/yang/Cisco-IOS-XE-bgp",
    "Cisco-IOS-XE-bgp-common-oper": "http://cisco.com/ns/yang/Cisco-IOS-XE-bgp-common-oper",
    "Cisco-IOS-XE-bgp-oper": "http://cisco.com/ns/yang/Cisco-IOS-XE-bgp-oper",
    "Cisco-IOS-XE-bgp-route-oper": "http://cisco.com/ns/yang/Cisco-IOS-XE-bgp-route-oper",
    "Cisco-IOS-XE-boot-integrity-oper": "http://cisco.com/ns/yang/Cisco-IOS-XE-boot-integrity-oper",
    "Cisco-IOS-XE-breakout-port-oper": "http://cisco.com/ns/yang/Cisco-IOS-XE-breakout-port-oper",
    "Cisco-IOS-XE-bridge-domain": "http://cisco.com/ns/yang/Cisco-IOS-XE-bridge-domain",
    "Cisco-IOS-XE-bridge-oper": "http://cisco.com/ns/yang/Cisco-IOS-XE-bridge-oper",
    "Cisco-IOS-XE-call-home": "http://cisco.com/ns/yang/Cisco-IOS-XE-call-home",
    "Cisco-IOS-XE-card": "http://cisco.com/ns/yang/Cisco-IOS-XE-card",
    "Cisco-IOS-XE-cdp": "http://cisco.com/ns/yang/Cisco-IOS-XE-cdp",
    "Cisco-IOS-XE-cdp-oper": "http://cisco.com/ns/yang/Cisco-IOS-XE-cdp-oper",
    "Cisco-IOS-XE-cef": "http://cisco.com/ns/yang/Cisco-IOS-XE-cef",
    "Cisco-IOS-XE-cellular": "http://cisco.com/ns/yang/Cisco-IOS-XE-cellular",
    "Cisco-IOS-XE-cellwan-oper": "http://cisco.com/ns/yang/Cisco-IOS-XE-cellwan-oper",
    "Cisco-IOS-XE-cfm-oper": "http://cisco.com/ns/yang/Cisco-IOS-XE-cfm-oper",
    "Cisco-IOS-XE-checkpoint-archive-oper": "http://cisco.com/ns/yang/Cisco-IOS-XE-checkpoint-archive-oper",
    "Cisco-IOS-XE-coap": "http://cisco.com/ns/yang/Cisco-IOS-XE-coap",
    "Cisco-IOS-XE-common-types": "http://cisco.com/ns/yang/Cisco-IOS-XE-common-types",
    "Cisco-IOS-XE-controller": "http://cisco.com/ns/yang/Cisco-IOS-XE-controller",
    "Cisco-IOS-XE-controller-vdsl-oper": "http://cisco.com/ns/yang/Cisco-IOS-XE-controller-vdsl-oper",
    "Cisco-IOS-XE-crypto": "http://cisco.com/ns/yang/Cisco-IOS-XE-crypto",
    "Cisco-IOS-XE-cts": "http://cisco.com/ns/yang/Cisco-IOS-XE-cts",
    "Cisco-IOS-XE-device-hardware-oper": "http://cisco.com/ns/yang/Cisco-IOS-XE-device-hardware-oper",
    "Cisco-IOS-XE-device-sensor": "http://cisco.com/ns/yang/Cisco-IOS-XE-device-sensor",
    "Cisco-IOS-XE-device-tracking": "http://cisco.com/ns/yang/Cisco-IOS-XE-device-tracking",
    "Cisco-IOS-XE-dhcp": "http://cisco.com/ns/yang/Cisco-IOS-XE-dhcp",
    "Cisco-IOS-XE-dhcp-oper": "http://cisco.com/ns/yang/Cisco-IOS-XE-dhcp-oper",
    "Cisco-IOS-XE-diagnostics": "http://cisco.com/ns/yang/Cisco-IOS-XE-diagnostics",
    "Cisco-IOS-XE-diffserv-target-oper": "http://cisco.com/ns/yang/Cisco-IOS-XE-diffserv-target-oper",
    "Cisco-IOS-XE-dot1x": "http://cisco.com/ns/yang/Cisco-IOS-XE-dot1x",
    "Cisco-IOS-XE-eem": "http://cisco.com/ns/yang/Cisco-IOS-XE-eem",
    "Cisco-IOS-XE-efp-oper": "http://cisco.com/ns/yang/Cisco-IOS-XE-efp-oper",
    "Cisco-IOS-XE-eigrp": "http://cisco.com/ns/yang/Cisco-IOS-XE-eigrp",
    "Cisco-IOS-XE-environment-oper": "http://cisco.com/ns/yang/Cisco-IOS-XE-environment-oper",
    "Cisco-IOS-XE-eta": "http://cisco.com/ns/yang/Cisco-IOS-XE-eta",
    "Cisco-IOS-XE-ethernet": "http://cisco.com/ns/yang/Cisco-IOS-XE-ethernet",
    "Cisco-IOS-XE-event-history-types": "http://cisco.com/ns/yang/Cisco-IOS-XE-event-history-types",
    "Cisco-IOS-XE-ezpm": "http://cisco.com/ns/yang/Cisco-IOS-XE-ezpm",
    "Cisco-IOS-XE-features": "http://cisco.com/ns/yang/Cisco-IOS-XE-features",
    "Cisco-IOS-XE-fib-oper": "http://cisco.com/ns/yang/Cisco-IOS-XE-fib-oper",
    "Cisco-IOS-XE-flow": "http://cisco.com/ns/yang/Cisco-IOS-XE-flow",
    "Cisco-IOS-XE-flow-monitor-oper": "http://cisco.com/ns/yang/Cisco-IOS-XE-flow-monitor-oper",
    "Cisco-IOS-XE-fw-oper": "http://cisco.com/ns/yang/Cisco-IOS-XE-fw-oper",
    "Cisco-IOS-XE-http": "http://cisco.com/ns/yang/Cisco-IOS-XE-http",
    "Cisco-IOS-XE-icmp": "http://cisco.com/ns/yang/Cisco-IOS-XE-icmp",
    "Cisco-IOS-XE-igmp": "http://cisco.com/ns/yang/Cisco-IOS-XE-igmp",
    "Cisco-IOS-XE-interface-common": "http://cisco.com/ns/yang/Cisco-IOS-XE-interface-common",
    "Cisco-IOS-XE-interfaces-oper": "http://cisco.com/ns/yang/Cisco-IOS-XE-interfaces-oper",
    "Cisco-IOS-XE-ios-common-oper": "http://cisco.com/ns/yang/Cisco-IOS-XE-ios-common-oper",
    "Cisco-IOS-XE-ios-events-oper": "http://cisco.com/ns/yang/Cisco-IOS-XE-ios-events-oper",
    "Cisco-IOS-XE-ip-sla-oper": "http://cisco.com/ns/yang/Cisco-IOS-XE-ip-sla-oper",
    "Cisco-IOS-XE-ipv6-oper": "http://cisco.com/ns/yang/Cisco-IOS-XE-ipv6-oper",
    "Cisco-IOS-XE-isis": "http://cisco.com/ns/yang/Cisco-IOS-XE-isis",
    "Cisco-IOS-XE-iwanfabric": "http://cisco.com/ns/yang/Cisco-IOS-XE-iwanfabric",
    "Cisco-IOS-XE-l2vpn": "http://cisco.com/ns/yang/Cisco-IOS-XE-l2vpn",
    "Cisco-IOS-XE-l3vpn": "http://cisco.com/ns/yang/Cisco-IOS-XE-l3vpn",
    "Cisco-IOS-XE-linecard-oper": "http://cisco.com/ns/yang/Cisco-IOS-XE-linecard-oper",
    "Cisco-IOS-XE-lisp": "http://cisco.com/ns/yang/Cisco-IOS-XE-lisp",
    "Cisco-IOS-XE-lisp-oper": "http://cisco.com/ns/yang/Cisco-IOS-XE-lisp-oper",
    "Cisco-IOS-XE-lldp": "http://cisco.com/ns/yang/Cisco-IOS-XE-lldp",
    "Cisco-IOS-XE-lldp-oper": "http://cisco.com/ns/yang/Cisco-IOS-XE-lldp-oper",
    "Cisco-IOS-XE-mdt-cfg": "http://cisco.com/ns/yang/Cisco-IOS-XE-mdt-cfg",
    "Cisco-IOS-XE-mdt-common-defs": "http://cisco.com/ns/yang/Cisco-IOS-XE-mdt-common-defs",
    "Cisco-IOS-XE-mdt-oper": "http://cisco.com/ns/yang/Cisco-IOS-XE-mdt-oper",
    "Cisco-IOS-XE-memory-oper": "http://cisco.com/ns/yang/Cisco-IOS-XE-memory-oper",
    "Cisco-IOS-XE-mka": "http://cisco.com/ns/yang/Cisco-IOS-XE-mka",
    "Cisco-IOS-XE-mld": "http://cisco.com/ns/yang/Cisco-IOS-XE-mld",
    "Cisco-IOS-XE-mmode": "http://cisco.com/ns/yang/Cisco-IOS-XE-mmode",
    "Cisco-IOS-XE-mpls": "http://cisco.com/ns/yang/Cisco-IOS-XE-mpls",
    "Cisco-IOS-XE-mpls-forwarding-oper": "http://cisco.com/ns/yang/Cisco-IOS-XE-mpls-forwarding-oper",
    "Cisco-IOS-XE-multicast": "http://cisco.com/ns/yang/Cisco-IOS-XE-multicast",
    "Cisco-IOS-XE-mvrp": "http://cisco.com/ns/yang/Cisco-IOS-XE-mvrp",
    "Cisco-IOS-XE-nam": "http://cisco.com/ns/yang/Cisco-IOS-XE-nam",
    "Cisco-IOS-XE-nat": "http://cisco.com/ns/yang/Cisco-IOS-XE-nat",
    "Cisco-IOS-XE-nat-oper": "http://cisco.com/ns/yang/Cisco-IOS-XE-nat-oper",
    "Cisco-IOS-XE-native": "http://cisco.com/ns/yang/Cisco-IOS-XE-native",
    "Cisco-IOS-XE-nbar": "http://cisco.com/ns/yang/Cisco-IOS-XE-nbar",
    "Cisco-IOS-XE-nd": "http://cisco.com/ns/yang/Cisco-IOS-XE-nd",
    "Cisco-IOS-XE-nhrp": "http://cisco.com/ns/yang/Cisco-IOS-XE-nhrp",
    "Cisco-IOS-XE-ntp": "http://cisco.com/ns/yang/Cisco-IOS-XE-ntp",
    "Cisco-IOS-XE-ntp-oper": "http://cisco.com/ns/yang/Cisco-IOS-XE-ntp-oper",
    "Cisco-IOS-XE-object-group": "http://cisco.com/ns/yang/Cisco-IOS-XE-object-group",
    "Cisco-IOS-XE-ospf": "http://cisco.com/ns/yang/Cisco-IOS-XE-ospf",
    "Cisco-IOS-XE-ospf-oper": "http://cisco.com/ns/yang/Cisco-IOS-XE-ospf-oper",
    "Cisco-IOS-XE-ospfv3": "http://cisco.com/ns/yang/Cisco-IOS-XE-ospfv3",
    "Cisco-IOS-XE-otv": "http://cisco.com/ns/yang/Cisco-IOS-XE-otv",
    "Cisco-IOS-XE-pathmgr": "http://cisco.com/ns/yang/Cisco-IOS-XE-pathmgr",
    "Cisco-IOS-XE-pfr": "http://cisco.com/ns/yang/Cisco-IOS-XE-pfr",
    "Cisco-IOS-XE-platform": "http://cisco.com/ns/yang/Cisco-IOS-XE-platform",
    "Cisco-IOS-XE-platform-oper": "http://cisco.com/ns/yang/Cisco-IOS-XE-platform-oper",
    "Cisco-IOS-XE-platform-software-oper": "http://cisco.com/ns/yang/Cisco-IOS-XE-platform-software-oper",
    "Cisco-IOS-XE-poe-oper": "http://cisco.com/ns/yang/Cisco-IOS-XE-poe-oper",
    "Cisco-IOS-XE-policy": "http://cisco.com/ns/yang/Cisco-IOS-XE-policy",
    "Cisco-IOS-XE-power": "http://cisco.com/ns/yang/Cisco-IOS-XE-power",
    "Cisco-IOS-XE-ppp": "http://cisco.com/ns/yang/Cisco-IOS-XE-ppp",
    "Cisco-IOS-XE-ppp-oper": "http://cisco.com/ns/yang/Cisco-IOS-XE-ppp-oper",
    "Cisco-IOS-XE-process-cpu-oper": "http://cisco.com/ns/yang/Cisco-IOS-XE-process-cpu-oper",
    "Cisco-IOS-XE-process-memory-oper": "http://cisco.com/ns/yang/Cisco-IOS-XE-process-memory-oper",
    "Cisco-IOS-XE-ptp": "http://cisco.com/ns/yang/Cisco-IOS-XE-ptp",
    "Cisco-IOS-XE-qos": "http://cisco.com/ns/yang/Cisco-IOS-XE-qos",
    "Cisco-IOS-XE-rip": "http://cisco.com/ns/yang/Cisco-IOS-XE-rip",
    "Cisco-IOS-XE-route-map": "http://cisco.com/ns/yang/Cisco-IOS-XE-route-map",
    "Cisco-IOS-XE-rpc": "http://cisco.com/ns/yang/Cisco-IOS-XE-rpc",
    "Cisco-IOS-XE-rsvp": "http://cisco.com/ns/yang/Cisco-IOS-XE-rsvp",
    "Cisco-IOS-XE-sanet": "http://cisco.com/ns/yang/Cisco-IOS-XE-sanet",
    "Cisco-IOS-XE-segment-routing": "http://cisco.com/ns/yang/Cisco-IOS-XE-segment-routing",
    "Cisco-IOS-XE-service-chain": "http://cisco.com/ns/yang/Cisco-IOS-XE-service-chain",
    "Cisco-IOS-XE-service-discovery": "http://cisco.com/ns/yang/Cisco-IOS-XE-service-discovery",
    "Cisco-IOS-XE-service-insertion": "http://cisco.com/ns/yang/Cisco-IOS-XE-service-insertion",
    "Cisco-IOS-XE-service-routing": "http://cisco.com/ns/yang/Cisco-IOS-XE-service-routing",
    "Cisco-IOS-XE-sla": "http://cisco.com/ns/yang/Cisco-IOS-XE-sla",
    "Cisco-IOS-XE-snmp": "http://cisco.com/ns/yang/Cisco-IOS-XE-snmp",
    "Cisco-IOS-XE-spanning-tree": "http://cisco.com/ns/yang/Cisco-IOS-XE-spanning-tree",
    "Cisco-IOS-XE-spanning-tree-oper": "http://cisco.com/ns/yang/Cisco-IOS-XE-spanning-tree-oper",
    "Cisco-IOS-XE-stackwise-virtual": "http://cisco.com/ns/yang/Cisco-IOS-XE-stackwise-virtual",
    "Cisco-IOS-XE-switch": "http://cisco.com/ns/yang/Cisco-IOS-XE-switch",
    "Cisco-IOS-XE-tcam-oper": "http://cisco.com/ns/yang/Cisco-IOS-XE-tcam-oper",
    "Cisco-IOS-XE-template": "http://cisco.com/ns/yang/ios-xe/template",
    "Cisco-IOS-XE-track": "http://cisco.com/ns/yang/Cisco-IOS-XE-track",
    "Cisco-IOS-XE-transceiver-oper": "http://cisco.com/ns/yang/Cisco-IOS-XE-transceiver-oper",
    "Cisco-IOS-XE-trustsec-oper": "http://cisco.com/ns/yang/Cisco-IOS-XE-trustsec-oper",
    "Cisco-IOS-XE-tunnel": "http://cisco.com/ns/yang/Cisco-IOS-XE-tunnel",
    "Cisco-IOS-XE-types": "http://cisco.com/ns/yang/Cisco-IOS-XE-types",
    "Cisco-IOS-XE-udld": "http://cisco.com/ns/yang/Cisco-IOS-XE-udld",
    "Cisco-IOS-XE-umbrella": "http://cisco.com/ns/yang/Cisco-IOS-XE-umbrella",
    "Cisco-IOS-XE-utd": "http://cisco.com/ns/yang/Cisco-IOS-XE-utd",
    "Cisco-IOS-XE-utd-common-oper": "http://cisco.com/ns/yang/Cisco-IOS-XE-utd-common-oper",
    "Cisco-IOS-XE-utd-oper": "http://cisco.com/ns/yang/Cisco-IOS-XE-utd-oper",
    "Cisco-IOS-XE-virtual-service-cfg": "http://cisco.com/ns/yang/Cisco-IOS-XE-virtual-service-cfg",
    "Cisco-IOS-XE-virtual-service-oper": "http://cisco.com/ns/yang/Cisco-IOS-XE-virtual-service-oper",
    "Cisco-IOS-XE-vlan": "http://cisco.com/ns/yang/Cisco-IOS-XE-vlan",
    "Cisco-IOS-XE-vlan-oper": "http://cisco.com/ns/yang/Cisco-IOS-XE-vlan-oper",
    "Cisco-IOS-XE-voice": "http://cisco.com/ns/yang/Cisco-IOS-XE-voice",
    "Cisco-IOS-XE-vpdn": "http://cisco.com/ns/yang/Cisco-IOS-XE-vpdn",
    "Cisco-IOS-XE-vrrp": "http://cisco.com/ns/yang/Cisco-IOS-XE-vrrp",
    "Cisco-IOS-XE-vrrp-oper": "http://cisco.com/ns/yang/Cisco-IOS-XE-vrrp-oper",
    "Cisco-IOS-XE-vservice": "http://cisco.com/ns/yang/Cisco-IOS-XE-vservice",
    "Cisco-IOS-XE-vstack": "http://cisco.com/ns/yang/Cisco-IOS-XE-vstack",
    "Cisco-IOS-XE-vtp": "http://cisco.com/ns/yang/Cisco-IOS-XE-vtp",
    "Cisco-IOS-XE-wccp": "http://cisco.com/ns/yang/Cisco-IOS-XE-wccp",
    "Cisco-IOS-XE-wsma": "http://cisco.com/ns/yang/Cisco-IOS-XE-wsma",
    "Cisco-IOS-XE-zone": "http://cisco.com/ns/yang/Cisco-IOS-XE-zone",
    "DIAL-CONTROL-MIB": "urn:ietf:params:xml:ns:yang:smiv2:DIAL-CONTROL-MIB",
    "DIFFSERV-DSCP-TC": "urn:ietf:params:xml:ns:yang:smiv2:DIFFSERV-DSCP-TC",
    "DIFFSERV-MIB": "urn:ietf:params:xml:ns:yang:smiv2:DIFFSERV-MIB",
    "DISMAN-EVENT-MIB": "urn:ietf:params:xml:ns:yang:smiv2:DISMAN-EVENT-MIB",
    "DISMAN-EXPRESSION-MIB": "urn:ietf:params:xml:ns:yang:smiv2:DISMAN-EXPRESSION-MIB",
    "DOCS-CABLE-DEVICE-MIB": "urn:ietf:params:xml:ns:yang:smiv2:DOCS-CABLE-DEVICE-MIB",
    "DOCS-IETF-BPI2-MIB": "urn:ietf:params:xml:ns:yang:smiv2:DOCS-IETF-BPI2-MIB",
    "DOCS-IF3-MIB": "urn:ietf:params:xml:ns:yang:smiv2:DOCS-IF3-MIB",
    "DOCS-IF-MIB": "urn:ietf:params:xml:ns:yang:smiv2:DOCS-IF-MIB",
    "DOCS-L2VPN-MIB": "urn:ietf:params:xml:ns:yang:smiv2:DOCS-L2VPN-MIB",
    "DOCS-QOS-MIB": "urn:ietf:params:xml:ns:yang:smiv2:DOCS-QOS-MIB",
    "DOCS-SUBMGT3-MIB": "urn:ietf:params:xml:ns:yang:smiv2:DOCS-SUBMGT3-MIB",
    "DRAFT-MSDP-MIB": "urn:ietf:params:xml:ns:yang:smiv2:DRAFT-MSDP-MIB",
    "DS1-MIB": "urn:ietf:params:xml:ns:yang:smiv2:DS1-MIB",
    "DS3-MIB": "urn:ietf:params:xml:ns:yang:smiv2:DS3-MIB",
    "ENTITY-MIB": "urn:ietf:params:xml:ns:yang:smiv2:ENTITY-MIB",
    "ENTITY-SENSOR-MIB": "urn:ietf:params:xml:ns:yang:smiv2:ENTITY-SENSOR-MIB",
    "ENTITY-STATE-MIB": "urn:ietf:params:xml:ns:yang:smiv2:ENTITY-STATE-MIB",
    "ENTITY-STATE-TC-MIB": "urn:ietf:params:xml:ns:yang:smiv2:ENTITY-STATE-TC-MIB",
    "ETHER-WIS": "urn:ietf:params:xml:ns:yang:smiv2:ETHER-WIS",
    "EXPRESSION-MIB": "urn:ietf:params:xml:ns:yang:smiv2:EXPRESSION-MIB",
    "EtherLike-MIB": "urn:ietf:params:xml:ns:yang:smiv2:EtherLike-MIB",
    "FRAME-RELAY-DTE-MIB": "urn:ietf:params:xml:ns:yang:smiv2:FRAME-RELAY-DTE-MIB",
    "HCNUM-TC": "urn:ietf:params:xml:ns:yang:smiv2:HCNUM-TC",
    "IANA-ADDRESS-FAMILY-NUMBERS-MIB": "urn:ietf:params:xml:ns:yang:smiv2:IANA-ADDRESS-FAMILY-NUMBERS-MIB",
    "IANA-RTPROTO-MIB": "urn:ietf:params:xml:ns:yang:smiv2:IANA-RTPROTO-MIB",
    "IANAifType-MIB": "urn:ietf:params:xml:ns:yang:smiv2:IANAifType-MIB",
    "IEEE8021-TC-MIB": "urn:ietf:params:xml:ns:yang:smiv2:IEEE8021-TC-MIB",
    "IF-MIB": "urn:ietf:params:xml:ns:yang:smiv2:IF-MIB",
    "IGMP-STD-MIB": "urn:ietf:params:xml:ns:yang:smiv2:IGMP-STD-MIB",
    "INET-ADDRESS-MIB": "urn:ietf:params:xml:ns:yang:smiv2:INET-ADDRESS-MIB",
    "INTEGRATED-SERVICES-MIB": "urn:ietf:params:xml:ns:yang:smiv2:INTEGRATED-SERVICES-MIB",
    "INT-SERV-MIB": "urn:ietf:params:xml:ns:yang:smiv2:INT-SERV-MIB",
    "IPMROUTE-STD-MIB": "urn:ietf:params:xml:ns:yang:smiv2:IPMROUTE-STD-MIB",
    "IPV6-FLOW-LABEL-MIB": "urn:ietf:params:xml:ns:yang:smiv2:IPV6-FLOW-LABEL-MIB",
    "IP-FORWARD-MIB": "urn:ietf:params:xml:ns:yang:smiv2:IP-FORWARD-MIB",
    "IP-MIB": "urn:ietf:params:xml:ns:yang:smiv2:IP-MIB",
    "LLDP-MIB": "urn:ietf:params:xml:ns:yang:smiv2:LLDP-MIB",
    "MPLS-L3VPN-STD-MIB": "urn:ietf:params:xml:ns:yang:smiv2:MPLS-L3VPN-STD-MIB",
    "MPLS-LDP-GENERIC-STD-MIB": "urn:ietf:params:xml:ns:yang:smiv2:MPLS-LDP-GENERIC-STD-MIB",
    "MPLS-LDP-STD-MIB": "urn:ietf:params:xml:ns:yang:smiv2:MPLS-LDP-STD-MIB",
    "MPLS-LSR-STD-MIB": "urn:ietf:params:xml:ns:yang:smiv2:MPLS-LSR-STD-MIB",
    "MPLS-TC-MIB": "urn:ietf:params:xml:ns:yang:smiv2:MPLS-TC-MIB",
    "MPLS-TC-STD-MIB": "urn:ietf:params:xml:ns:yang:smiv2:MPLS-TC-STD-MIB",
    "MPLS-TE-STD-MIB": "urn:ietf:params:xml:ns:yang:smiv2:MPLS-TE-STD-MIB",
    "MPLS-VPN-MIB": "urn:ietf:params:xml:ns:yang:smiv2:MPLS-VPN-MIB",
    "NHRP-MIB": "urn:ietf:params:xml:ns:yang:smiv2:NHRP-MIB",
    "NOTIFICATION-LOG-MIB": "urn:ietf:params:xml:ns:yang:smiv2:NOTIFICATION-LOG-MIB",
    "OLD-CISCO-INTERFACES-MIB": "urn:ietf:params:xml:ns:yang:smiv2:OLD-CISCO-INTERFACES-MIB",
    "OSPF-MIB": "urn:ietf:params:xml:ns:yang:smiv2:OSPF-MIB",
    "OSPF-TRAP-MIB": "urn:ietf:params:xml:ns:yang:smiv2:OSPF-TRAP-MIB",
    "PIM-MIB": "urn:ietf:params:xml:ns:yang:smiv2:PIM-MIB",
    "POWER-ETHERNET-MIB": "urn:ietf:params:xml:ns:yang:smiv2:POWER-ETHERNET-MIB",
    "P-BRIDGE-MIB": "urn:ietf:params:xml:ns:yang:smiv2:P-BRIDGE-MIB",
    "PerfHist-TC-MIB": "urn:ietf:params:xml:ns:yang:smiv2:PerfHist-TC-MIB",
    "Q-BRIDGE-MIB": "urn:ietf:params:xml:ns:yang:smiv2:Q-BRIDGE-MIB",
    "RFC1155-SMI": "urn:ietf:params:xml:ns:yang:smiv2:RFC1155-SMI",
    "RFC1213-MIB": "urn:ietf:params:xml:ns:yang:smiv2:RFC1213-MIB",
    "RFC1315-MIB": "urn:ietf:params:xml:ns:yang:smiv2:RFC1315-MIB",
    "RFC-1212": "urn:ietf:params:xml:ns:yang:smiv2:RFC-1212",
    "RFC-1215": "urn:ietf:params:xml:ns:yang:smiv2:RFC-1215",
    "RMON2-MIB": "urn:ietf:params:xml:ns:yang:smiv2:RMON2-MIB",
    "RMON-MIB": "urn:ietf:params:xml:ns:yang:smiv2:RMON-MIB",
    "RSVP-MIB": "urn:ietf:params:xml:ns:yang:smiv2:RSVP-MIB",
    "SNMP-FRAMEWORK-MIB": "urn:ietf:params:xml:ns:yang:smiv2:SNMP-FRAMEWORK-MIB",
    "SNMP-PROXY-MIB": "urn:ietf:params:xml:ns:yang:smiv2:SNMP-PROXY-MIB",
    "SNMP-TARGET-MIB": "urn:ietf:params:xml:ns:yang:smiv2:SNMP-TARGET-MIB",
    "SNMPv2-MIB": "urn:ietf:params:xml:ns:yang:smiv2:SNMPv2-MIB",
    "SNMPv2-TC": "urn:ietf:params:xml:ns:yang:smiv2:SNMPv2-TC",
    "SONET-MIB": "urn:ietf:params:xml:ns:yang:smiv2:SONET-MIB",
    "TCP-MIB": "urn:ietf:params:xml:ns:yang:smiv2:TCP-MIB",
    "TOKENRING-MIB": "urn:ietf:params:xml:ns:yang:smiv2:TOKENRING-MIB",
    "TOKEN-RING-RMON-MIB": "urn:ietf:params:xml:ns:yang:smiv2:TOKEN-RING-RMON-MIB",
    "TUNNEL-MIB": "urn:ietf:params:xml:ns:yang:smiv2:TUNNEL-MIB",
    "UDP-MIB": "urn:ietf:params:xml:ns:yang:smiv2:UDP-MIB",
    "VPN-TC-STD-MIB": "urn:ietf:params:xml:ns:yang:smiv2:VPN-TC-STD-MIB",
    "cisco-bridge-common": "urn:cisco:params:xml:ns:yang:cisco-bridge-common",
    "cisco-bridge-domain": "urn:cisco:params:xml:ns:yang:cisco-bridge-domain",
    "cisco-ethernet": "urn:cisco:params:xml:ns:yang:cisco-ethernet",
    "cisco-ia": "http://cisco.com/yang/cisco-ia",
    "cisco-ospf": "urn:ietf:params:xml:ns:yang:cisco-ospf",
    "cisco-policy": "urn:ietf:params:xml:ns:yang:cisco-policy",
    "cisco-policy-filters": "urn:ietf:params:xml:ns:yang:cisco-policy-filters",
    "cisco-policy-target": "urn:ietf:params:xml:ns:yang:cisco-policy-target",
    "cisco-pw": "urn:cisco:params:xml:ns:yang:pw",
    "cisco-routing-ext": "urn:cisco:params:xml:ns:yang:cisco-routing-ext",
    "cisco-self-mgmt": "http://cisco.com/yang/cisco-self-mgmt",
    "cisco-smart-license": "http://cisco.com/ns/yang/cisco-smart-license",
    "cisco-storm-control": "urn:cisco:params:xml:ns:yang:cisco-storm-control",
    "common-mpls-static": "urn:ietf:params:xml:ns:yang:common-mpls-static",
    "common-mpls-types": "urn:ietf:params:xml:ns:yang:common-mpls-types",
    "nvo": "urn:ietf:params:xml:ns:yang:nvo",
    "pim": "urn:cisco:params:xml:ns:yang:pim",
    "policy-attr": "urn:ietf:params:xml:ns:yang:policy-attr",
    "policy-types": "urn:ietf:params:xml:ns:yang:c3pl-types",
    "policy-types": "urn:ietf:params:xml:ns:yang:c3pl-types",
    "tailf-common": "http://tail-f.com/yang/common",
    "tailf-common-monitoring": "http://tail-f.com/yang/common-monitoring",
    "tailf-common-query": "http://tail-f.com/ns/common/query",
    "tailf-confd-monitoring": "http://tail-f.com/yang/confd-monitoring",
    "tailf-netconf-inactive": "http://tail-f.com/ns/netconf/inactive/1.0",
    "tailf-netconf-monitoring": "http://tail-f.com/yang/netconf-monitoring",
    "tailf-netconf-query": "http://tail-f.com/ns/netconf/query",
    "tailf-netconf-transactions": "http://tail-f.com/ns/netconf/transactions/1.0",
    "tailf-rest-error": "http://tail-f.com/ns/tailf-rest-error",
    "tailf-rest-query": "http://tail-f.com/ns/tailf-rest-query",
    "tailf-xsd-types": "http://www.w3.org/2001/XMLSchema",
}

IDENTITY_LOOKUP = {
    'ATM-TC-MIB:atmClpNoTaggingMcr':('ydk.models.cisco_ios_xe.ATM_TC_MIB', 'AtmClpNoTaggingMcr'),
    'ATM-TC-MIB:atmClpNoTaggingNoScr':('ydk.models.cisco_ios_xe.ATM_TC_MIB', 'AtmClpNoTaggingNoScr'),
    'ATM-TC-MIB:atmClpNoTaggingScr':('ydk.models.cisco_ios_xe.ATM_TC_MIB', 'AtmClpNoTaggingScr'),
    'ATM-TC-MIB:atmClpNoTaggingScrCdvt':('ydk.models.cisco_ios_xe.ATM_TC_MIB', 'AtmClpNoTaggingScrCdvt'),
    'ATM-TC-MIB:atmClpTaggingNoScr':('ydk.models.cisco_ios_xe.ATM_TC_MIB', 'AtmClpTaggingNoScr'),
    'ATM-TC-MIB:atmClpTaggingScr':('ydk.models.cisco_ios_xe.ATM_TC_MIB', 'AtmClpTaggingScr'),
    'ATM-TC-MIB:atmClpTaggingScrCdvt':('ydk.models.cisco_ios_xe.ATM_TC_MIB', 'AtmClpTaggingScrCdvt'),
    'ATM-TC-MIB:atmClpTransparentNoScr':('ydk.models.cisco_ios_xe.ATM_TC_MIB', 'AtmClpTransparentNoScr'),
    'ATM-TC-MIB:atmClpTransparentScr':('ydk.models.cisco_ios_xe.ATM_TC_MIB', 'AtmClpTransparentScr'),
    'ATM-TC-MIB:atmNoClpNoScr':('ydk.models.cisco_ios_xe.ATM_TC_MIB', 'AtmNoClpNoScr'),
    'ATM-TC-MIB:atmNoClpNoScrCdvt':('ydk.models.cisco_ios_xe.ATM_TC_MIB', 'AtmNoClpNoScrCdvt'),
    'ATM-TC-MIB:atmNoClpScr':('ydk.models.cisco_ios_xe.ATM_TC_MIB', 'AtmNoClpScr'),
    'ATM-TC-MIB:atmNoClpScrCdvt':('ydk.models.cisco_ios_xe.ATM_TC_MIB', 'AtmNoClpScrCdvt'),
    'ATM-TC-MIB:atmNoClpTaggingNoScr':('ydk.models.cisco_ios_xe.ATM_TC_MIB', 'AtmNoClpTaggingNoScr'),
    'ATM-TC-MIB:atmNoTrafficDescriptor':('ydk.models.cisco_ios_xe.ATM_TC_MIB', 'AtmNoTrafficDescriptor'),
    'CISCO-SIP-UA-MIB:ciscoSipUaMIBNotificationPrefix':('ydk.models.cisco_ios_xe.CISCO_SIP_UA_MIB', 'CiscoSipUaMIBNotificationPrefix'),
    'CISCO-SIP-UA-MIB:ciscoSipUaMIBNotifications':('ydk.models.cisco_ios_xe.CISCO_SIP_UA_MIB', 'CiscoSipUaMIBNotifications'),
    'CISCO-SMI:cisco2505RptrGroup':('ydk.models.cisco_ios_xe.CISCO_SMI', 'Cisco2505RptrGroup'),
    'CISCO-SMI:cisco2507RptrGroup':('ydk.models.cisco_ios_xe.CISCO_SMI', 'Cisco2507RptrGroup'),
    'CISCO-SMI:cisco2516RptrGroup':('ydk.models.cisco_ios_xe.CISCO_SMI', 'Cisco2516RptrGroup'),
    'CISCO-SMI:ciscoAdmin':('ydk.models.cisco_ios_xe.CISCO_SMI', 'CiscoAdmin'),
    'CISCO-SMI:ciscoAgentCapability':('ydk.models.cisco_ios_xe.CISCO_SMI', 'CiscoAgentCapability'),
    'CISCO-SMI:ciscoCIB':('ydk.models.cisco_ios_xe.CISCO_SMI', 'CiscoCIB'),
    'CISCO-SMI:ciscoChipSetSaint1':('ydk.models.cisco_ios_xe.CISCO_SMI', 'CiscoChipSetSaint1'),
    'CISCO-SMI:ciscoChipSetSaint2':('ydk.models.cisco_ios_xe.CISCO_SMI', 'CiscoChipSetSaint2'),
    'CISCO-SMI:ciscoChipSetSaint3':('ydk.models.cisco_ios_xe.CISCO_SMI', 'CiscoChipSetSaint3'),
    'CISCO-SMI:ciscoChipSetSaint4':('ydk.models.cisco_ios_xe.CISCO_SMI', 'CiscoChipSetSaint4'),
    'CISCO-SMI:ciscoChipSets':('ydk.models.cisco_ios_xe.CISCO_SMI', 'CiscoChipSets'),
    'CISCO-SMI:ciscoCibMmiGroup':('ydk.models.cisco_ios_xe.CISCO_SMI', 'CiscoCibMmiGroup'),
    'CISCO-SMI:ciscoCibProvGroup':('ydk.models.cisco_ios_xe.CISCO_SMI', 'CiscoCibProvGroup'),
    'CISCO-SMI:ciscoConfig':('ydk.models.cisco_ios_xe.CISCO_SMI', 'CiscoConfig'),
    'CISCO-SMI:ciscoDomains':('ydk.models.cisco_ios_xe.CISCO_SMI', 'CiscoDomains'),
    'CISCO-SMI:ciscoExperiment':('ydk.models.cisco_ios_xe.CISCO_SMI', 'CiscoExperiment'),
    'CISCO-SMI:ciscoMgmt':('ydk.models.cisco_ios_xe.CISCO_SMI', 'CiscoMgmt'),
    'CISCO-SMI:ciscoModules':('ydk.models.cisco_ios_xe.CISCO_SMI', 'CiscoModules'),
    'CISCO-SMI:ciscoPIB':('ydk.models.cisco_ios_xe.CISCO_SMI', 'CiscoPIB'),
    'CISCO-SMI:ciscoPKI':('ydk.models.cisco_ios_xe.CISCO_SMI', 'CiscoPKI'),
    'CISCO-SMI:ciscoPartnerProducts':('ydk.models.cisco_ios_xe.CISCO_SMI', 'CiscoPartnerProducts'),
    'CISCO-SMI:ciscoPibToMib':('ydk.models.cisco_ios_xe.CISCO_SMI', 'CiscoPibToMib'),
    'CISCO-SMI:ciscoPolicy':('ydk.models.cisco_ios_xe.CISCO_SMI', 'CiscoPolicy'),
    'CISCO-SMI:ciscoPolicyAuto':('ydk.models.cisco_ios_xe.CISCO_SMI', 'CiscoPolicyAuto'),
    'CISCO-SMI:ciscoProducts':('ydk.models.cisco_ios_xe.CISCO_SMI', 'CiscoProducts'),
    'CISCO-SMI:ciscoProxy':('ydk.models.cisco_ios_xe.CISCO_SMI', 'CiscoProxy'),
    'CISCO-SMI:ciscoRptrGroupObjectID':('ydk.models.cisco_ios_xe.CISCO_SMI', 'CiscoRptrGroupObjectID'),
    'CISCO-SMI:ciscoSB':('ydk.models.cisco_ios_xe.CISCO_SMI', 'CiscoSB'),
    'CISCO-SMI:ciscoSMB':('ydk.models.cisco_ios_xe.CISCO_SMI', 'CiscoSMB'),
    'CISCO-SMI:ciscoTDomainClns':('ydk.models.cisco_ios_xe.CISCO_SMI', 'CiscoTDomainClns'),
    'CISCO-SMI:ciscoTDomainCons':('ydk.models.cisco_ios_xe.CISCO_SMI', 'CiscoTDomainCons'),
    'CISCO-SMI:ciscoTDomainDdp':('ydk.models.cisco_ios_xe.CISCO_SMI', 'CiscoTDomainDdp'),
    'CISCO-SMI:ciscoTDomainIpx':('ydk.models.cisco_ios_xe.CISCO_SMI', 'CiscoTDomainIpx'),
    'CISCO-SMI:ciscoTDomainLocal':('ydk.models.cisco_ios_xe.CISCO_SMI', 'CiscoTDomainLocal'),
    'CISCO-SMI:ciscoTDomainSctpIpv4':('ydk.models.cisco_ios_xe.CISCO_SMI', 'CiscoTDomainSctpIpv4'),
    'CISCO-SMI:ciscoTDomainSctpIpv6':('ydk.models.cisco_ios_xe.CISCO_SMI', 'CiscoTDomainSctpIpv6'),
    'CISCO-SMI:ciscoTDomainTcpIpv4':('ydk.models.cisco_ios_xe.CISCO_SMI', 'CiscoTDomainTcpIpv4'),
    'CISCO-SMI:ciscoTDomainTcpIpv6':('ydk.models.cisco_ios_xe.CISCO_SMI', 'CiscoTDomainTcpIpv6'),
    'CISCO-SMI:ciscoTDomainUdpIpv4':('ydk.models.cisco_ios_xe.CISCO_SMI', 'CiscoTDomainUdpIpv4'),
    'CISCO-SMI:ciscoTDomainUdpIpv6':('ydk.models.cisco_ios_xe.CISCO_SMI', 'CiscoTDomainUdpIpv6'),
    'CISCO-SMI:ciscoUnknownRptrGroup':('ydk.models.cisco_ios_xe.CISCO_SMI', 'CiscoUnknownRptrGroup'),
    'CISCO-SMI:ciscoWsx5020RptrGroup':('ydk.models.cisco_ios_xe.CISCO_SMI', 'CiscoWsx5020RptrGroup'),
    'CISCO-SMI:ciscoworks':('ydk.models.cisco_ios_xe.CISCO_SMI', 'Ciscoworks'),
    'CISCO-SMI:lightstream':('ydk.models.cisco_ios_xe.CISCO_SMI', 'Lightstream'),
    'CISCO-SMI:local':('ydk.models.cisco_ios_xe.CISCO_SMI', 'Local'),
    'CISCO-SMI:newport':('ydk.models.cisco_ios_xe.CISCO_SMI', 'Newport'),
    'CISCO-SMI:otherEnterprises':('ydk.models.cisco_ios_xe.CISCO_SMI', 'OtherEnterprises'),
    'CISCO-SMI:pakmon':('ydk.models.cisco_ios_xe.CISCO_SMI', 'Pakmon'),
    'CISCO-SMI:temporary':('ydk.models.cisco_ios_xe.CISCO_SMI', 'Temporary'),
    'CISCO-SMI:workgroup':('ydk.models.cisco_ios_xe.CISCO_SMI', 'Workgroup'),
    'Cisco-IOS-XE-diffserv-target-oper:direction':('ydk.models.cisco_ios_xe.Cisco_IOS_XE_diffserv_target_oper', 'Direction'),
    'Cisco-IOS-XE-diffserv-target-oper:inbound':('ydk.models.cisco_ios_xe.Cisco_IOS_XE_diffserv_target_oper', 'Inbound'),
    'Cisco-IOS-XE-diffserv-target-oper:outbound':('ydk.models.cisco_ios_xe.Cisco_IOS_XE_diffserv_target_oper', 'Outbound'),
    'DIFFSERV-MIB:diffServSchedulerPriority':('ydk.models.cisco_ios_xe.DIFFSERV_MIB', 'DiffServSchedulerPriority'),
    'DIFFSERV-MIB:diffServSchedulerWFQ':('ydk.models.cisco_ios_xe.DIFFSERV_MIB', 'DiffServSchedulerWFQ'),
    'DIFFSERV-MIB:diffServSchedulerWRR':('ydk.models.cisco_ios_xe.DIFFSERV_MIB', 'DiffServSchedulerWRR'),
    'DIFFSERV-MIB:diffServTBParamAvgRate':('ydk.models.cisco_ios_xe.DIFFSERV_MIB', 'DiffServTBParamAvgRate'),
    'DIFFSERV-MIB:diffServTBParamSimpleTokenBucket':('ydk.models.cisco_ios_xe.DIFFSERV_MIB', 'DiffServTBParamSimpleTokenBucket'),
    'DIFFSERV-MIB:diffServTBParamSrTCMAware':('ydk.models.cisco_ios_xe.DIFFSERV_MIB', 'DiffServTBParamSrTCMAware'),
    'DIFFSERV-MIB:diffServTBParamSrTCMBlind':('ydk.models.cisco_ios_xe.DIFFSERV_MIB', 'DiffServTBParamSrTCMBlind'),
    'DIFFSERV-MIB:diffServTBParamTrTCMAware':('ydk.models.cisco_ios_xe.DIFFSERV_MIB', 'DiffServTBParamTrTCMAware'),
    'DIFFSERV-MIB:diffServTBParamTrTCMBlind':('ydk.models.cisco_ios_xe.DIFFSERV_MIB', 'DiffServTBParamTrTCMBlind'),
    'DIFFSERV-MIB:diffServTBParamTswTCM':('ydk.models.cisco_ios_xe.DIFFSERV_MIB', 'DiffServTBParamTswTCM'),
    'EtherLike-MIB:dot3ErrorInitError':('ydk.models.cisco_ios_xe.EtherLike_MIB', 'Dot3ErrorInitError'),
    'EtherLike-MIB:dot3ErrorLoopbackError':('ydk.models.cisco_ios_xe.EtherLike_MIB', 'Dot3ErrorLoopbackError'),
    'EtherLike-MIB:dot3TestLoopBack':('ydk.models.cisco_ios_xe.EtherLike_MIB', 'Dot3TestLoopBack'),
    'EtherLike-MIB:dot3TestTdr':('ydk.models.cisco_ios_xe.EtherLike_MIB', 'Dot3TestTdr'),
    'RMON-MIB:rmonEventsV2':('ydk.models.cisco_ios_xe.RMON_MIB', 'RmonEventsV2'),
    'SNMP-FRAMEWORK-MIB:snmpAuthProtocols':('ydk.models.cisco_ios_xe.SNMP_FRAMEWORK_MIB', 'SnmpAuthProtocols'),
    'SNMP-FRAMEWORK-MIB:snmpPrivProtocols':('ydk.models.cisco_ios_xe.SNMP_FRAMEWORK_MIB', 'SnmpPrivProtocols'),
    'TOKENRING-MIB:dot5ChipSetIBM16':('ydk.models.cisco_ios_xe.TOKENRING_MIB', 'Dot5ChipSetIBM16'),
    'TOKENRING-MIB:dot5ChipSetTItms380':('ydk.models.cisco_ios_xe.TOKENRING_MIB', 'Dot5ChipSetTItms380'),
    'TOKENRING-MIB:dot5ChipSetTItms380c16':('ydk.models.cisco_ios_xe.TOKENRING_MIB', 'Dot5ChipSetTItms380c16'),
    'TOKENRING-MIB:dot5TestFullDuplexLoopBack':('ydk.models.cisco_ios_xe.TOKENRING_MIB', 'Dot5TestFullDuplexLoopBack'),
    'TOKENRING-MIB:dot5TestInsertFunc':('ydk.models.cisco_ios_xe.TOKENRING_MIB', 'Dot5TestInsertFunc'),
    'cisco-bridge-common:mac-limit-notification-type':('ydk.models.cisco_ios_xe.cisco_bridge_common', 'MacLimitNotificationType'),
    'cisco-bridge-common:notif-none':('ydk.models.cisco_ios_xe.cisco_bridge_common', 'NotifNone'),
    'cisco-bridge-common:notif-snmp-trap':('ydk.models.cisco_ios_xe.cisco_bridge_common', 'NotifSnmpTrap'),
    'cisco-bridge-common:notif-syslog':('ydk.models.cisco_ios_xe.cisco_bridge_common', 'NotifSyslog'),
    'cisco-bridge-common:notif-syslog-and-snmp-trap':('ydk.models.cisco_ios_xe.cisco_bridge_common', 'NotifSyslogAndSnmpTrap'),
    'cisco-ethernet:eth-if-speed':('ydk.models.cisco_ios_xe.cisco_ethernet', 'EthIfSpeed'),
    'cisco-ethernet:eth-if-speed-100gb':('ydk.models.cisco_ios_xe.cisco_ethernet', 'EthIfSpeed100gb'),
    'cisco-ethernet:eth-if-speed-100mb':('ydk.models.cisco_ios_xe.cisco_ethernet', 'EthIfSpeed100mb'),
    'cisco-ethernet:eth-if-speed-10gb':('ydk.models.cisco_ios_xe.cisco_ethernet', 'EthIfSpeed10gb'),
    'cisco-ethernet:eth-if-speed-10mb':('ydk.models.cisco_ios_xe.cisco_ethernet', 'EthIfSpeed10mb'),
    'cisco-ethernet:eth-if-speed-1gb':('ydk.models.cisco_ios_xe.cisco_ethernet', 'EthIfSpeed1gb'),
    'cisco-ethernet:eth-if-speed-40gb':('ydk.models.cisco_ios_xe.cisco_ethernet', 'EthIfSpeed40gb'),
    'cisco-pw:pw-encap-mpls':('ydk.models.cisco_ios_xe.cisco_pw', 'PwEncapMpls'),
    'cisco-pw:pw-encapsulation-type':('ydk.models.cisco_ios_xe.cisco_pw', 'PwEncapsulationType'),
    'cisco-pw:pw-lb-eth-dst-mac':('ydk.models.cisco_ios_xe.cisco_pw', 'PwLbEthDstMac'),
    'cisco-pw:pw-lb-eth-src-dst-mac':('ydk.models.cisco_ios_xe.cisco_pw', 'PwLbEthSrcDstMac'),
    'cisco-pw:pw-lb-eth-src-mac':('ydk.models.cisco_ios_xe.cisco_pw', 'PwLbEthSrcMac'),
    'cisco-pw:pw-lb-ethernet-type':('ydk.models.cisco_ios_xe.cisco_pw', 'PwLbEthernetType'),
    'cisco-pw:pw-lb-ip-dst-ip':('ydk.models.cisco_ios_xe.cisco_pw', 'PwLbIpDstIp'),
    'cisco-pw:pw-lb-ip-src-dst-ip':('ydk.models.cisco_ios_xe.cisco_pw', 'PwLbIpSrcDstIp'),
    'cisco-pw:pw-lb-ip-src-ip':('ydk.models.cisco_ios_xe.cisco_pw', 'PwLbIpSrcIp'),
    'cisco-pw:pw-lb-ip-type':('ydk.models.cisco_ios_xe.cisco_pw', 'PwLbIpType'),
    'cisco-pw:pw-load-balance-type':('ydk.models.cisco_ios_xe.cisco_pw', 'PwLoadBalanceType'),
    'cisco-pw:pw-sequencing-both':('ydk.models.cisco_ios_xe.cisco_pw', 'PwSequencingBoth'),
    'cisco-pw:pw-sequencing-receive':('ydk.models.cisco_ios_xe.cisco_pw', 'PwSequencingReceive'),
    'cisco-pw:pw-sequencing-transmit':('ydk.models.cisco_ios_xe.cisco_pw', 'PwSequencingTransmit'),
    'cisco-pw:pw-sequencing-type':('ydk.models.cisco_ios_xe.cisco_pw', 'PwSequencingType'),
    'cisco-pw:pw-signaling-protocol-bgp':('ydk.models.cisco_ios_xe.cisco_pw', 'PwSignalingProtocolBgp'),
    'cisco-pw:pw-signaling-protocol-ldp':('ydk.models.cisco_ios_xe.cisco_pw', 'PwSignalingProtocolLdp'),
    'cisco-pw:pw-signaling-protocol-none':('ydk.models.cisco_ios_xe.cisco_pw', 'PwSignalingProtocolNone'),
    'cisco-pw:pw-signaling-protocol-type':('ydk.models.cisco_ios_xe.cisco_pw', 'PwSignalingProtocolType'),
    'cisco-pw:pw-vc-type':('ydk.models.cisco_ios_xe.cisco_pw', 'PwVcType'),
    'cisco-pw:pw-vc-type-ether':('ydk.models.cisco_ios_xe.cisco_pw', 'PwVcTypeEther'),
    'cisco-pw:pw-vc-type-vlan':('ydk.models.cisco_ios_xe.cisco_pw', 'PwVcTypeVlan'),
    'cisco-pw:pw-vc-type-vlan-passthrough':('ydk.models.cisco_ios_xe.cisco_pw', 'PwVcTypeVlanPassthrough'),
    'cisco-routing-ext:bgp':('ydk.models.cisco_ios_xe.cisco_routing_ext', 'Bgp'),
    'cisco-routing-ext:eigrp':('ydk.models.cisco_ios_xe.cisco_routing_ext', 'Eigrp'),
    'cisco-routing-ext:hsrp':('ydk.models.cisco_ios_xe.cisco_routing_ext', 'Hsrp'),
    'cisco-routing-ext:igrp':('ydk.models.cisco_ios_xe.cisco_routing_ext', 'Igrp'),
    'cisco-routing-ext:is-is':('ydk.models.cisco_ios_xe.cisco_routing_ext', 'IsIs'),
    'cisco-routing-ext:lisp':('ydk.models.cisco_ios_xe.cisco_routing_ext', 'Lisp'),
    'cisco-routing-ext:nhrp':('ydk.models.cisco_ios_xe.cisco_routing_ext', 'Nhrp'),
    'cisco-routing-ext:rip':('ydk.models.cisco_ios_xe.cisco_routing_ext', 'Rip'),
    'cisco-storm-control:action-drop':('ydk.models.cisco_ios_xe.cisco_storm_control', 'ActionDrop'),
    'cisco-storm-control:action-shutdown':('ydk.models.cisco_ios_xe.cisco_storm_control', 'ActionShutdown'),
    'cisco-storm-control:action-snmp-trap':('ydk.models.cisco_ios_xe.cisco_storm_control', 'ActionSnmpTrap'),
    'cisco-storm-control:storm-control-action':('ydk.models.cisco_ios_xe.cisco_storm_control', 'StormControlAction'),
    'common-mpls-static:bgp-route-nexthop':('ydk.models.cisco_ios_xe.common_mpls_static', 'BgpRouteNexthop'),
    'common-mpls-static:isis-route-nexthop':('ydk.models.cisco_ios_xe.common_mpls_static', 'IsisRouteNexthop'),
    'common-mpls-static:lsp':('ydk.models.cisco_ios_xe.common_mpls_static', 'Lsp'),
    'common-mpls-static:lsp-IPv4':('ydk.models.cisco_ios_xe.common_mpls_static', 'LspIPv4'),
    'common-mpls-static:lsp-IPv6':('ydk.models.cisco_ios_xe.common_mpls_static', 'LspIPv6'),
    'common-mpls-static:lsp-type':('ydk.models.cisco_ios_xe.common_mpls_static', 'LspType'),
    'common-mpls-static:lsp-vrf':('ydk.models.cisco_ios_xe.common_mpls_static', 'LspVrf'),
    'common-mpls-static:nexthop-resolution-type':('ydk.models.cisco_ios_xe.common_mpls_static', 'NexthopResolutionType'),
    'common-mpls-static:ospf-route-nexthop':('ydk.models.cisco_ios_xe.common_mpls_static', 'OspfRouteNexthop'),
    'common-mpls-static:static-nexthop':('ydk.models.cisco_ios_xe.common_mpls_static', 'StaticNexthop'),
    'nvo:nvgre-type':('ydk.models.cisco_ios_xe.nvo', 'NvgreType'),
    'nvo:overlay-encap-type':('ydk.models.cisco_ios_xe.nvo', 'OverlayEncapType'),
    'nvo:vxlan-type':('ydk.models.cisco_ios_xe.nvo', 'VxlanType'),
    'pim:asm-mapping-mode':('ydk.models.cisco_ios_xe.pim', 'AsmMappingMode'),
    'pim:dm-mapping-mode':('ydk.models.cisco_ios_xe.pim', 'DmMappingMode'),
    'pim:group-to-rp-mapping-mode':('ydk.models.cisco_ios_xe.pim', 'GroupToRpMappingMode'),
    'pim:other-mapping-mode':('ydk.models.cisco_ios_xe.pim', 'OtherMappingMode'),
    'pim:pim-bidir-mapping-mode':('ydk.models.cisco_ios_xe.pim', 'PimBidirMappingMode'),
    'pim:sm-mapping-mode':('ydk.models.cisco_ios_xe.pim', 'SmMappingMode'),
    'pim:ssm-mapping-mode':('ydk.models.cisco_ios_xe.pim', 'SsmMappingMode'),
    'policy-types:access-control':('ydk.models.cisco_ios_xe.policy_types', 'AccessControl'),
    'policy-types:access-control-class':('ydk.models.cisco_ios_xe.policy_types', 'AccessControlClass'),
    'policy-types:application':('ydk.models.cisco_ios_xe.policy_types', 'Application'),
    'policy-types:appnav':('ydk.models.cisco_ios_xe.policy_types', 'Appnav'),
    'policy-types:appnav-class':('ydk.models.cisco_ios_xe.policy_types', 'AppnavClass'),
    'policy-types:atm-clp':('ydk.models.cisco_ios_xe.policy_types', 'AtmClp'),
    'policy-types:atm-vci':('ydk.models.cisco_ios_xe.policy_types', 'AtmVci'),
    'policy-types:class-map':('ydk.models.cisco_ios_xe.policy_types', 'ClassMap'),
    'policy-types:class-type':('ydk.models.cisco_ios_xe.policy_types', 'ClassType'),
    'policy-types:control':('ydk.models.cisco_ios_xe.policy_types', 'Control'),
    'policy-types:control-class':('ydk.models.cisco_ios_xe.policy_types', 'ControlClass'),
    'policy-types:cos':('ydk.models.cisco_ios_xe.policy_types', 'Cos'),
    'policy-types:cos-inner':('ydk.models.cisco_ios_xe.policy_types', 'CosInner'),
    'policy-types:dei':('ydk.models.cisco_ios_xe.policy_types', 'Dei'),
    'policy-types:dei-inner':('ydk.models.cisco_ios_xe.policy_types', 'DeiInner'),
    'policy-types:discard-class':('ydk.models.cisco_ios_xe.policy_types', 'DiscardClass'),
    'policy-types:dst-mac':('ydk.models.cisco_ios_xe.policy_types', 'DstMac'),
    'policy-types:flow-de':('ydk.models.cisco_ios_xe.policy_types', 'FlowDe'),
    'policy-types:flow-dlci':('ydk.models.cisco_ios_xe.policy_types', 'FlowDlci'),
    'policy-types:flow-ip':('ydk.models.cisco_ios_xe.policy_types', 'FlowIp'),
    'policy-types:flow-record':('ydk.models.cisco_ios_xe.policy_types', 'FlowRecord'),
    'policy-types:input-interface':('ydk.models.cisco_ios_xe.policy_types', 'InputInterface'),
    'policy-types:inspect':('ydk.models.cisco_ios_xe.policy_types', 'Inspect'),
    'policy-types:inspect-class':('ydk.models.cisco_ios_xe.policy_types', 'InspectClass'),
    'policy-types:ip-rtp':('ydk.models.cisco_ios_xe.policy_types', 'IpRtp'),
    'policy-types:ipv4-acl':('ydk.models.cisco_ios_xe.policy_types', 'Ipv4Acl'),
    'policy-types:ipv4-acl-name':('ydk.models.cisco_ios_xe.policy_types', 'Ipv4AclName'),
    'policy-types:ipv6-acl':('ydk.models.cisco_ios_xe.policy_types', 'Ipv6Acl'),
    'policy-types:ipv6-acl-name':('ydk.models.cisco_ios_xe.policy_types', 'Ipv6AclName'),
    'policy-types:metadata':('ydk.models.cisco_ios_xe.policy_types', 'Metadata'),
    'policy-types:mpls-exp-imp':('ydk.models.cisco_ios_xe.policy_types', 'MplsExpImp'),
    'policy-types:mpls-exp-top':('ydk.models.cisco_ios_xe.policy_types', 'MplsExpTop'),
    'policy-types:packet-length':('ydk.models.cisco_ios_xe.policy_types', 'PacketLength'),
    'policy-types:packet-service':('ydk.models.cisco_ios_xe.policy_types', 'PacketService'),
    'policy-types:pbr':('ydk.models.cisco_ios_xe.policy_types', 'Pbr'),
    'policy-types:perf-mon':('ydk.models.cisco_ios_xe.policy_types', 'PerfMon'),
    'policy-types:policy-type':('ydk.models.cisco_ios_xe.policy_types', 'PolicyType'),
    'policy-types:prec':('ydk.models.cisco_ios_xe.policy_types', 'Prec'),
    'policy-types:qos':('ydk.models.cisco_ios_xe.policy_types', 'Qos'),
    'policy-types:qos-class':('ydk.models.cisco_ios_xe.policy_types', 'QosClass'),
    'policy-types:qos-group':('ydk.models.cisco_ios_xe.policy_types', 'QosGroup'),
    'policy-types:security-group-name':('ydk.models.cisco_ios_xe.policy_types', 'SecurityGroupName'),
    'policy-types:security-group-tag':('ydk.models.cisco_ios_xe.policy_types', 'SecurityGroupTag'),
    'policy-types:service':('ydk.models.cisco_ios_xe.policy_types', 'Service'),
    'policy-types:src-mac':('ydk.models.cisco_ios_xe.policy_types', 'SrcMac'),
    'policy-types:vlan':('ydk.models.cisco_ios_xe.policy_types', 'Vlan'),
    'policy-types:vlan-inner':('ydk.models.cisco_ios_xe.policy_types', 'VlanInner'),
    'policy-types:vpls':('ydk.models.cisco_ios_xe.policy_types', 'Vpls'),
    'policy-types:wlan-user-priority':('ydk.models.cisco_ios_xe.policy_types', 'WlanUserPriority'),
    'policy-types:access-control':('ydk.models.cisco_ios_xe.policy_types', 'AccessControl'),
    'policy-types:access-control-class':('ydk.models.cisco_ios_xe.policy_types', 'AccessControlClass'),
    'policy-types:application':('ydk.models.cisco_ios_xe.policy_types', 'Application'),
    'policy-types:appnav':('ydk.models.cisco_ios_xe.policy_types', 'Appnav'),
    'policy-types:appnav-class':('ydk.models.cisco_ios_xe.policy_types', 'AppnavClass'),
    'policy-types:atm-clp':('ydk.models.cisco_ios_xe.policy_types', 'AtmClp'),
    'policy-types:atm-vci':('ydk.models.cisco_ios_xe.policy_types', 'AtmVci'),
    'policy-types:class-map':('ydk.models.cisco_ios_xe.policy_types', 'ClassMap'),
    'policy-types:class-type':('ydk.models.cisco_ios_xe.policy_types', 'ClassType'),
    'policy-types:control':('ydk.models.cisco_ios_xe.policy_types', 'Control'),
    'policy-types:control-class':('ydk.models.cisco_ios_xe.policy_types', 'ControlClass'),
    'policy-types:cos':('ydk.models.cisco_ios_xe.policy_types', 'Cos'),
    'policy-types:cos-inner':('ydk.models.cisco_ios_xe.policy_types', 'CosInner'),
    'policy-types:dei':('ydk.models.cisco_ios_xe.policy_types', 'Dei'),
    'policy-types:dei-inner':('ydk.models.cisco_ios_xe.policy_types', 'DeiInner'),
    'policy-types:discard-class':('ydk.models.cisco_ios_xe.policy_types', 'DiscardClass'),
    'policy-types:dst-mac':('ydk.models.cisco_ios_xe.policy_types', 'DstMac'),
    'policy-types:flow-de':('ydk.models.cisco_ios_xe.policy_types', 'FlowDe'),
    'policy-types:flow-dlci':('ydk.models.cisco_ios_xe.policy_types', 'FlowDlci'),
    'policy-types:flow-ip':('ydk.models.cisco_ios_xe.policy_types', 'FlowIp'),
    'policy-types:flow-record':('ydk.models.cisco_ios_xe.policy_types', 'FlowRecord'),
    'policy-types:input-interface':('ydk.models.cisco_ios_xe.policy_types', 'InputInterface'),
    'policy-types:inspect':('ydk.models.cisco_ios_xe.policy_types', 'Inspect'),
    'policy-types:inspect-class':('ydk.models.cisco_ios_xe.policy_types', 'InspectClass'),
    'policy-types:ip-rtp':('ydk.models.cisco_ios_xe.policy_types', 'IpRtp'),
    'policy-types:ipv4-acl':('ydk.models.cisco_ios_xe.policy_types', 'Ipv4Acl'),
    'policy-types:ipv4-acl-name':('ydk.models.cisco_ios_xe.policy_types', 'Ipv4AclName'),
    'policy-types:ipv6-acl':('ydk.models.cisco_ios_xe.policy_types', 'Ipv6Acl'),
    'policy-types:ipv6-acl-name':('ydk.models.cisco_ios_xe.policy_types', 'Ipv6AclName'),
    'policy-types:metadata':('ydk.models.cisco_ios_xe.policy_types', 'Metadata'),
    'policy-types:mpls-exp-imp':('ydk.models.cisco_ios_xe.policy_types', 'MplsExpImp'),
    'policy-types:mpls-exp-top':('ydk.models.cisco_ios_xe.policy_types', 'MplsExpTop'),
    'policy-types:packet-length':('ydk.models.cisco_ios_xe.policy_types', 'PacketLength'),
    'policy-types:packet-service':('ydk.models.cisco_ios_xe.policy_types', 'PacketService'),
    'policy-types:pbr':('ydk.models.cisco_ios_xe.policy_types', 'Pbr'),
    'policy-types:perf-mon':('ydk.models.cisco_ios_xe.policy_types', 'PerfMon'),
    'policy-types:policy-type':('ydk.models.cisco_ios_xe.policy_types', 'PolicyType'),
    'policy-types:prec':('ydk.models.cisco_ios_xe.policy_types', 'Prec'),
    'policy-types:qos':('ydk.models.cisco_ios_xe.policy_types', 'Qos'),
    'policy-types:qos-class':('ydk.models.cisco_ios_xe.policy_types', 'QosClass'),
    'policy-types:qos-group':('ydk.models.cisco_ios_xe.policy_types', 'QosGroup'),
    'policy-types:security-group-name':('ydk.models.cisco_ios_xe.policy_types', 'SecurityGroupName'),
    'policy-types:security-group-tag':('ydk.models.cisco_ios_xe.policy_types', 'SecurityGroupTag'),
    'policy-types:service':('ydk.models.cisco_ios_xe.policy_types', 'Service'),
    'policy-types:src-mac':('ydk.models.cisco_ios_xe.policy_types', 'SrcMac'),
    'policy-types:vlan':('ydk.models.cisco_ios_xe.policy_types', 'Vlan'),
    'policy-types:vlan-inner':('ydk.models.cisco_ios_xe.policy_types', 'VlanInner'),
    'policy-types:vpls':('ydk.models.cisco_ios_xe.policy_types', 'Vpls'),
    'policy-types:wlan-user-priority':('ydk.models.cisco_ios_xe.policy_types', 'WlanUserPriority'),
    'tailf-netconf-monitoring:cli-console':('ydk.models.cisco_ios_xe.tailf_netconf_monitoring', 'CliConsole'),
    'tailf-netconf-monitoring:cli-ssh':('ydk.models.cisco_ios_xe.tailf_netconf_monitoring', 'CliSsh'),
    'tailf-netconf-monitoring:cli-tcp':('ydk.models.cisco_ios_xe.tailf_netconf_monitoring', 'CliTcp'),
    'tailf-netconf-monitoring:netconf-tcp':('ydk.models.cisco_ios_xe.tailf_netconf_monitoring', 'NetconfTcp'),
    'tailf-netconf-monitoring:rest-http':('ydk.models.cisco_ios_xe.tailf_netconf_monitoring', 'RestHttp'),
    'tailf-netconf-monitoring:rest-https':('ydk.models.cisco_ios_xe.tailf_netconf_monitoring', 'RestHttps'),
    'tailf-netconf-monitoring:snmp-udp':('ydk.models.cisco_ios_xe.tailf_netconf_monitoring', 'SnmpUdp'),
    'tailf-netconf-monitoring:webui-http':('ydk.models.cisco_ios_xe.tailf_netconf_monitoring', 'WebuiHttp'),
    'tailf-netconf-monitoring:webui-https':('ydk.models.cisco_ios_xe.tailf_netconf_monitoring', 'WebuiHttps'),
}

